# higuide sourced to lower memory footprint
# modified to use loadConfig --btux9
# modified to handle checkboxes correctly (no value returned when unchecked)
  global db
  global guideindexdir
  global tzoffset
  global source_dir

    # must use indirection to get a value that will identify the repeat marker
  foreach g {Repeat HDTV Live CC} {
    variable ${g}index [expr {$::dtivo?[getGenreIndex $g 2]:-1}]
  }
  if {$HDTVindex == -1} {
    variable HDTVindex [expr {$::dtivo?[getGenreIndex "High-Def" 2]:-1}]
  }

  set upvDepth 0
  set nowsecs [expr ([clock seconds] + $tzoffset)]
  set nowdate [expr $nowsecs - ($nowsecs % 86400)]
  set nowdate [expr $nowdate / 86400]
  set date $nowdate

  set submit ""
  eval_env

  #if lower form buttons pressed, process them
  if { ($submit == "Save") || ($submit == "Submit") } {
    # set all unset guide(op_*) variables (form only returns checked)
    foreach v {showUSTVicon showhdicon showCCicon showMPAAicon shownew showrec showsp showdes showhd showfin refresh showsug showcon} {
      set v "guide(op_$v)"
      set $v [expr {[info exist $v]?"on":"off"}]
    }
    if { $submit == "Save" } {
      guide_save_preferences guide $chan
    }
  } else {
    #else get defaults
    loadConfigArr guide [loadConfig higuide]
  }
  #override with specific values passed
  eval_env

  regsub -all {[^0-9.-]+} $guide(op_chan_cust) { } guide(op_chan_cust)
  regsub -all { +} $guide(op_chan_cust) { } guide(op_chan_cust)

  update_sp_cache
  set guide(start_hour_raw) $guide(start_hour)
  set guide(end_hour_raw) $guide(end_hour)
  if { $guide(start_hour) < 0 } {
    set guide(start_hour) [expr (($nowsecs - ($nowdate*86400)) / 3600) +1+$guide(start_hour) ]
    if { $guide(start_hour) < 0 } {
      set guide(start_hour) [expr $guide(start_hour) + 24]
      incr date -1
    }
  }
  if { $guide(end_hour) < 0 } {
    set guide(end_hour) [expr $guide(start_hour) - $guide(end_hour_raw)]
    if { $guide(end_hour) > 24 } {
      set guide(end_hour) [expr $guide(end_hour) - 24]
    }
  }

  # start and end secs are both in local time
  set startsecs [expr ($date * 86400) + ($guide(start_hour) * 3600)]
  set endsecs [expr ($date * 86400) + ($guide(end_hour) * 3600)]
  if {$endsecs <= $startsecs} {
    set endsecs [expr $endsecs + 86400]
  }
  set enddate [expr $endsecs / 86400]

  # we need utc info for the file lookups since both the names and the contents are utc based
  set startsecsutc [expr $startsecs - $tzoffset]
  set endsecsutc [expr $endsecs - $tzoffset]
  set startdateutc [expr $startsecsutc / 86400]
  set enddateutc [expr $endsecsutc / 86400]

  set datesutc $startdateutc
  if {$startdateutc != $enddateutc} {
    lappend datesutc $enddateutc
  }
  set dates $date

  if { $enddate != $date } {
    lappend dates [expr $enddate]
  }

  if {[clock format $startsecs -format "%D"] != [clock format $endsecs -format "%D"]} {
    # if the range crosses the day, specify everything in both parts
    set dateTimeRange "[clock format $startsecs -format "%A %b %d %Y "][string trim [clock format $startsecs -format "%l%p"] "\t\n\{\} "]-[clock format $endsecs -format "%A %b %d %Y "][string trim [clock format $endsecs -format "%l%p"] "\t\n\{\} "]"
  } elseif {[clock format $startsecs -format "%A %b %d %Y %p"] != [clock format $endsecs -format "%A %b %d %Y %p"]} {
    # if the range crosses noon, specify AM/PM in both parts
    set dateTimeRange "[clock format $startsecs -format "%A %b %d %Y "][string trim [clock format $startsecs -format "%l%p"] "\t\n\{\} "]-[string trim [clock format $endsecs -format "%l%p"] "\t\n\{\} "]"
  } else {
    # don't repeat the day month year AM-PM if not necessary
    set dateTimeRange "[clock format $startsecs -format "%A %b %d %Y "][string trim [clock format $startsecs -format "%l"] "\t\n\{\} "]-[string trim [clock format $endsecs -format "%l%p"] "\t\n\{\} "]"
  }

  set rangesecs [expr $endsecs - $startsecs]

  ## setup earlier and later times
  set diffsecs [expr $endsecs - $startsecs - 3600]
  if { $diffsecs <= 0 } {
    set diffsecs 3600
  }
  set earlier_start_hour [expr (($startsecs - $diffsecs) % 86400) / 3600 ]
  set earlier_end_hour [expr (($endsecs - $diffsecs) % 86400) / 3600 ]
  set earlier_date [expr ($startsecs - $diffsecs) / 86400]
  set later_start_hour [expr (($startsecs + $diffsecs) % 86400) / 3600 ]
  set later_end_hour [expr (($endsecs + $diffsecs) % 86400) / 3600 ]
  set later_date [expr ($startsecs + $diffsecs) / 86400]

  if { $earlier_end_hour == 0 } {
    set earlier_end_hour 24
  }
  if { $later_end_hour == 0 } {
    set later_end_hour 24
  }

  set height [lindex {15 63 42} $guide(op_height)]
  set pct [lindex {0 0 64} $guide(op_height)]

  # set the refresh period for the page if requested
  set refreshString ""
  if { $guide(op_refresh) == "on" } {
    # seconds to the top of the hour
    set refreshSecs [expr 3600 - ([clock seconds] % 3600)]
    # add up to four minutes of random seconds to avoid multiple browsers pounding the server at the same time
    incr refreshSecs [expr int(rand()*240)]
    set refreshString "<META HTTP-EQUIV=\"refresh\" content=\"$refreshSecs\">\n"
  }
  # put together style information
  set styles "<STYLE type=\"text/css\">"
  append styles "<!--\n"
  append styles "table.higuide td { border-left: 1px solid #888888; border-bottom: 1px solid #888888; height:${height}px; }"
  append styles "table.higuide th { text-align:left; text-weight:bold; border-left: 1px solid #888888; }"
  append styles "table.higuide td   { font-weight:bold; font-size:.7em; white-space: nowrap; }"
  append styles "table.higuide td a { font-weight:bold; white-space: nowrap; }"
  append styles "table.higuide td.def { background:$guide(def_bg); color:$guide(def_fg); }"
  append styles "table.higuide td.def a { color:$guide(def_fg); }"
  append styles "table.higuide td.fin { background:$guide(fin_bg); color:$guide(fin_fg); }"
  append styles "table.higuide td.fin a { color:$guide(fin_fg); }"
  append styles "table.higuide td.rec { background:$guide(rec_bg); color:$guide(rec_fg); }"
  append styles "table.higuide td.rec a { color:$guide(rec_fg); }"
  append styles "table.higuide td.sug { background:$guide(sug_bg); color:$guide(sug_fg); }"
  append styles "table.higuide td.sug a { color:$guide(sug_fg); }"
  append styles "table.higuide td.con { background:$guide(con_bg); color:$guide(con_fg); }"
  append styles "table.higuide td.con a { color:$guide(con_fg); }"
  append styles "table.higuide td.hdv { background:$guide(hdv_bg); color:$guide(hdv_fg); }"
  append styles "table.higuide td.hdv a { color:$guide(hdv_fg); }"
  append styles "table.higuide tr.status td { height:5px; border-left: 1px solid #888888; }"
  append styles "-->\n"
  append styles "</STYLE>"
  #put styles into header
  puts $chan [html_start "HiGuide $dateTimeRange" $refreshString $styles]

  if { $submit == "Save" } {
    puts $chan "Preferences Saved!<br>"
  }

  set segment_size 5
  set seg_size_secs [expr $segment_size * 60]
  set num_whole_mins [expr 24 * 60]
  set num_whole_secs [expr $num_whole_mins * 60]
  set num_seg_mins [expr $num_whole_mins / $segment_size]
  set num_thirty_mins [expr $num_whole_mins / 30]
  set segment_width 3
  set start_seg [expr ($guide(start_hour)*60) / $segment_size]
  set end_seg [expr ($guide(end_hour)*60) / $segment_size]
  set now_secs $nowsecs
  set now_secs [expr $now_secs - ($now_secs % $seg_size_secs)]

  # todo information
  for {set i $startsecs} {$i < $endsecs} {incr i $seg_size_secs} {
    # set each segment to 0 (0=no recording, 1=recording)
    set segment_active($i) 0
  }
  set reasons(nothing) "HELLO"
  # get todo
  set fsids ""
  foreach date $datesutc {
    ForeachMfsFile fsid name type "/Recording/Active" "4:$date:" {
      lappend fsids $fsid
    }
  }
  # get currently recording (if it exists!)
  foreach date $datesutc {
    RetryTransaction {
      set fsid [lindex [get_fsidbyprefix "/Recording/Active" "3:$date:"] 0]
    }
    if { $fsid != "" } {
      lappend fsids $fsid
      break
    }
  }
  foreach fsid $fsids {
    RetryTransaction {
      set todo_rec [db $db openid $fsid]
      set todo_showing [dbobj $todo_rec get Showing]
      set todo_program [dbobj $todo_showing get Program]
      set todo_title [string trim [dbobj $todo_program get Title] "\t\n\{\} "]
      set todo_station [dbobj $todo_showing get Station]
      set todo_station_name [string trim [dbobj $todo_station get Name] "\t\n\{\} "]
      set todo_time [dbobj $todo_showing get Time]
      set todo_startpadding [dbobj $todo_rec get StartPadding]
      if {$todo_startpadding != ""} {
        set todo_time  [expr $todo_time - $todo_startpadding]
      } else {
        set todo_startpadding 0
      }
      set todo_date [dbobj $todo_showing get Date]
      set todo_duration [dbobj $todo_showing get Duration]
      set todo_endpadding [dbobj $todo_rec get EndPadding]
      if {$todo_endpadding != ""} {
        set todo_duration  [expr $todo_duration + $todo_endpadding + $todo_startpadding]
      }
      set todo_seltype [dbobj $todo_rec get SelectionType]
      set todo_stationfsid [dbobj $todo_station fsid]
      set secs [expr $todo_date * 86400 + $todo_time + $tzoffset]
      set reasons($secs:$todo_stationfsid) $todo_seltype
      if { $todo_seltype != 6 } {
        for {set i $secs} {$i<[expr $secs + $todo_duration]} {incr i $seg_size_secs} {
        set segment_active($i) 1
        set segment_title($i) "$todo_title ($todo_station_name)"
        }
      }
    }
  }
  # Get channel information and put selection into channel_sel
  # and get channel names/fsids to put in selection
  lappend chanvals -1
  lappend chanlabs "All"
  lappend chanvals -2
  lappend chanlabs "Favourites"
  lappend chanvals -3
  lappend chanlabs "Custom"
  set channel_sel ""

  #foreach stationfsid $::channelSort
  ForeachChannel chinfo 1 {
    lappend chanvals $chinfo(fsid)
    lappend chanlabs [strim $chinfo(name)]
  }
  if {$guide(op_chan)==-2} {set filter 2} else {set filter 1}
  ForeachChannel chinfo $filter {
    if {$guide(op_chan)>0 && $chinfo(fsid)!=$guide(op_chan)} continue
    if {$guide(op_chan)==-3 && [lsearch $guide(op_chan_cust) $chinfo(num)]<0} continue

    if { $guide(op_height) != "0" } {
      set logostr [getLogoTag -pct $pct $chinfo(logo) 1 "$chinfo(sign)($chinfo(num))"]
    } else {
      set logostr "$chinfo(sign)"
    }
    lappend channel_sel [list $chinfo(fsid) $logostr "$chinfo(sign)($chinfo(num)):[strim $chinfo(name)]"]

  }
  set hasExtraHeight 0
  set show_seasonPass 0
  set show_firstShowing 0
  set show_ustvRatings 0
  set show_mpaaRatings 0
  set show_closedCaption 0
  set show_highDefinition 0

  if { $guide(op_height) != 0 } {
    set hasExtraHeight 1
    if { $guide(op_shownew) == "on" } {
      set show_firstShowing 1
    }
    if { $guide(op_showUSTVicon) == "on" } {
      set show_ustvRatings 1
    }
    if { $guide(op_showMPAAicon) == "on" } {
      set show_mpaaRatings 1
    }
    if { $guide(op_showCCicon) == "on" } {
      set show_closedCaption 1
    }
    if { $guide(op_showhdicon) == "on" } {
      set show_highDefinition 1
    }
    if { $guide(op_showsp) == "on" } {
      set show_seasonPass 1
    }
  }

  ## QUICK SELECTION TABLE
  puts $chan [html_form_start "POST" "/higuide" ""]
  puts $chan [html_table_start "" "" ""]
  set datestr [nth_sup [clock format [expr [lindex $dates 0]*86400] -format "%e"]]
  set datestr [clock format [expr [lindex $dates 0]*86400] -format "%a $datestr %b"]
  puts  $chan [tr "" [th "COLSPAN=7" "<B>$datestr</B>"]]

  puts $chan [tr "STYLE=font-size:11px" [td "COLSPAN=2 ALIGN=right" "Channel: "] [td "COLSPAN=4" [html_form_select "guide(op_chan)\" STYLE=\"font-size:11px" $chanvals $chanlabs $guide(op_chan)]] [td "" ""]]

  for {set i $nowdate} {$i<[expr $nowdate+14]} {incr i 1} {
    lappend dvals $i
    set tmp [nth [clock format [expr $i*86400] -format "%e"]]
    lappend dlabs [clock format [expr $i*86400] -format "%a $tmp %b"]
  }
  lappend shvals -1
  lappend shlabs "Now"
  for {set i 0} {$i<4} {incr i 1} {
    lappend shvals [expr ($i+2)*-1]
    lappend shlabs "Now-[expr $i+1]"
  }
  for {set i 0} {$i<24} {incr i 1} {
    lappend ehvals [expr ($i+1)*-1]
    lappend ehlabs "Current+[expr $i+1]"
  }
  for {set i 0} {$i<24} {incr i 1} {
    lappend shvals $i
    lappend shlabs "[format %02d $i]:00"
    lappend ehvals [expr $i+1]
    lappend ehlabs "[format %02d [expr $i+1]]:00"
  }

  set datesrch [td "" "Date: "]
  append datesrch [td "" [html_form_select "date\" STYLE=\"font-size:11px" $dvals $dlabs [lindex $dates 0]]]
  append datesrch [td "" "From: "]
  append datesrch [td "" [html_form_select "guide(start_hour)\" STYLE=\"font-size:11px" $shvals $shlabs $guide(start_hour_raw)]]
  append datesrch [td "" "To: "]
  append datesrch [td "" [html_form_select "guide(end_hour)\" STYLE=\"font-size:11px" $ehvals $ehlabs $guide(end_hour_raw)]]
  puts $chan [tr "STYLE=font-size:11px" "$datesrch [td "" [html_form_input "submit" "submit" "Go"]]"]
  puts $chan [html_table_end]
  puts $chan [html_form_end]
  puts $chan [bodytext_start]
  puts $chan [html_link "/higuide?date=[expr [lindex $dates 0] - 1]&guide(start_hour)=$guide(start_hour)&guide(end_hour)=$guide(end_hour)&guide(op_chan)=$guide(op_chan)&submit=Go" "<< Previous Day"]
  puts $chan [html_link "/higuide?date=$earlier_date&guide(start_hour)=$earlier_start_hour&guide(end_hour)=$earlier_end_hour&guide(op_chan)=$guide(op_chan)&submit=Go" "< Earlier"]
  puts $chan [html_link "/higuide?date=$nowdate&guide(start_hour)=$guide(start_hour)&guide(end_hour)=$guide(end_hour)&guide(op_chan)=$guide(op_chan)&submit=Go" "Today"]
  puts $chan [html_link "/higuide?date=$later_date&guide(start_hour)=$later_start_hour&guide(end_hour)=$later_end_hour&guide(op_chan)=$guide(op_chan)&submit=Go" "Later >"]
  puts $chan [html_link "/higuide?date=[expr [lindex $dates 0] + 1]&guide(start_hour)=$guide(start_hour)&guide(end_hour)=$guide(end_hour)&guide(op_chan)=$guide(op_chan)&submit=Go" "Next Day >>"]
  puts $chan [bodytext_end]

  puts $chan "<BR>"



  ### START OF MAIN TABLE
  puts $chan [html_table_start "border=1 STYLE=\"border-collapse:collapse; padding: 0; border: 0; width:95%;\"" "" ""]
  puts $chan "<tr><td VALIGN=top STYLE=\"width:100px;height:${height}px;right:0;\">"

  ### START OF CHANNEL TABLE
  
  puts $chan [html_table_start "CLASS=higuide" "" ""]
  puts $chan [tr "CLASS=status" [td "" "&nbsp;"]]
  puts $chan [tr "" [th "STYLE=\"text-align:center;\"" "Channel"]]
  foreach channel $channel_sel {
#    if {[info exists global_channelgrid_version] == 0} {
#      puts $chan [tr "" [td "" [lindex $channel 1]]]
#    } else {
      puts $chan [tr "" [td "" [html_link "/channelgrid?whichChannel=[lindex $channel 0]" [lindex $channel 1] [lindex $channel 2]]]]
#    }
  }
  puts $chan [html_table_end]
  ### END OF CHANNEL TABLE

  puts $chan "</td><td VALIGN=top STYLE=\"left:0;\">"

  puts $chan "<div STYLE=\"left:0;padding:0px;border:0;margin:0;overflow:auto;height:100% \">"

  ### START OF GUIDE TABLE
  puts $chan [html_table_start "CLASS=higuide STYLE=\"left:0;\"" "" ""]
  #First Row
  set row ""
  set space ""
  for {set i 0} {$i < $segment_width} {incr i 1} {
    append space "&nbsp;"
  }

  for {set i $startsecs} {$i < $endsecs} {incr i $seg_size_secs} {
    if { $i < $now_secs } {
      set style fin
      set row_text "$space"
    } elseif { $segment_active($i) == 1 } {
      set style rec
      set row_text "<a href=\# title=\"$segment_title($i)\">$space</a>"
      unset segment_title($i)
    } else {
      set style def
      set row_text "$space"
    }
    append row [td "CLASS=\"$style\"" "$row_text"]
  }
  puts $chan [tr "CLASS=status" $row]

  #Second Row
  set row ""
  for {set i $startsecs} {$i<$endsecs} {incr i 1800} {
    set time [clock format $i -format "%H:%M"]
    append row [th "COLSPAN=6" "$time"]
  }
  puts $chan [tr "" $row]
  unset row

  #Guide Rows
  foreach channel $channel_sel {
    puts $chan [tr "VALIGN=TOP" [do_guide_row $datesutc [lindex $channel 0]]]
  }

  puts $chan [html_table_end]
  ### END OF GUIDE TABLE

  puts $chan "</div>"
  puts $chan "</td></tr>"
  puts $chan [html_table_end]
  ### END OF MAIN TABLE

  #Preferences
  puts $chan [html_form_start "POST" "/higuide" ""]
  puts $chan [html_table_start "STYLE=font-size:11px" "" ""]

  puts $chan [tr "" [th "COLSPAN=3" "Option" ] [th "" "Background"] [th "" "Foreground"]]

  set autoRefresh ""
  if { $guide(op_refresh) == "on" } { set autoRefresh "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_refresh)" $autoRefresh]] [td "COLSPAN=4" "Auto-refresh at Top of the Hour"]]

  set options "tmp $guide(op_showrec) $guide(op_showsug) $guide(op_showcon) $guide(op_showfin) $guide(op_showhd)"
  set opt_nams "tmp guide(op_showrec) guide(op_showsug) guide(op_showcon) guide(op_showfin) guide(op_showhd)"
  #set opt_cols {{$guide_rec} {$guide_sug} {$guide_con} {$guide_new} {$guide_fin} {$guide_hdv}}
  lappend opt_cols_fg $guide(def_fg)
  lappend opt_cols_bg $guide(def_bg)
  lappend opt_cols_fg $guide(rec_fg)
  lappend opt_cols_bg $guide(rec_bg)
  lappend opt_cols_fg $guide(sug_fg)
  lappend opt_cols_bg $guide(sug_bg)
  lappend opt_cols_fg $guide(con_fg)
  lappend opt_cols_bg $guide(con_bg)
  lappend opt_cols_fg $guide(fin_fg)
  lappend opt_cols_bg $guide(fin_bg)
  lappend opt_cols_fg $guide(hdv_fg)
  lappend opt_cols_bg $guide(hdv_bg)
  set opt_cols_nams "def rec sug con fin hdv"
  set opt_texts {{Default} {Scheduled to record} {Scheduled suggestion} {Conflicting} {Finished} {HDTV}}

  for {set i 0} {$i<[llength $options]} {incr i 1} {
    set option [lindex $options $i]
    set opt_nam [lindex $opt_nams $i]
    set opt_col_fg [lindex $opt_cols_fg $i]
    set opt_col_bg [lindex $opt_cols_bg $i]
    set opt_col_nam [lindex $opt_cols_nams $i]
    set opt_text [lindex $opt_texts $i]

    if { $option == "on" } {
      set option "CHECKED"
    } else {
      set option ""
    }
    set checkbox ""
    if { $i > 0 } {
      set checkbox [html_form_checkbox $opt_nam $option]
    }
    set background [html_form_text 1 20 "guide($opt_col_nam\_bg)\" STYLE=\"font-size:11px" $opt_col_bg]
    set foreground [html_form_text 1 20 "guide($opt_col_nam\_fg)\" STYLE=\"font-size:11px" $opt_col_fg]

    puts $chan [tr "" [td "" $checkbox] [td "STYLE=font-size:11px" "$opt_text"] [td "STYLE=\"background:$opt_col_bg;color:$opt_col_fg;font-size:11px\"" "<b>Key</b>"] [td "" "$background"] [td "" "$foreground"]]
  }
  set showdes ""
  if { $guide(op_showdes) == "on" } { set showdes "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_showdes)" $showdes]] [td "COLSPAN=4" "Full description on mouse hover"]]

  set shownew ""
  if { $guide(op_shownew) == "on" } { set shownew "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_shownew)" $shownew]] [td "" "First Showing"] [td "COLSPAN=3" "(Not displayed in very thin mode)"]]

  if {$HDTVindex >= 0} {
    # only show the option if the possibility exists
    set showhdicon ""
    if { $guide(op_showhdicon) == "on" } { set showhdicon "CHECKED" }
    puts $chan [tr "" [td "" [html_form_checkbox "guide(op_showhdicon)" $showhdicon]] [td "" "HD Presentation Icon"] [td "COLSPAN=3" "(Not displayed in very thin mode)"]]
  }

  set showMPAAicon ""
  if { $guide(op_showMPAAicon) == "on" } { set showMPAAicon "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_showMPAAicon)" $showMPAAicon]] [td "" "MPAA Rating Icon"] [td "COLSPAN=3" "(Not displayed in very thin mode)"]]

  set showUSTVicon ""
  if { $guide(op_showUSTVicon) == "on" } { set showUSTVicon "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_showUSTVicon)" $showUSTVicon]] [td "" "US TV Rating Icon"] [td "COLSPAN=3" "(Not displayed in very thin mode)"]]

  set showCCicon ""
  if { $guide(op_showCCicon) == "on" } { set showCCicon "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_showCCicon)" $showCCicon]] [td "" "Close Caption Icon"] [td "COLSPAN=3" "(Not displayed in very thin mode)"]]

  set showsp ""
  if { $guide(op_showsp) == "on" } { set showsp "CHECKED" }
  puts $chan [tr "" [td "" [html_form_checkbox "guide(op_showsp)" $showsp]] [td "" "Season Pass"] [td "COLSPAN=3" "(Not displayed in very thin mode)"]]
  set radio1 "[html_form_input radio guide(op_height) 1]Thick "
  set radio2 "[html_form_input radio guide(op_height) 2]Thin "
  set radio0 "[html_form_input radio guide(op_height) 0]Very thin"
  set checked "radio$guide(op_height)"
  regsub {>} [subst $$checked] { CHECKED>} checkedresult
  set $checked $checkedresult
  puts $chan [tr "" [td "" "" ] [td "" "Grid height"] [td "COLSPAN=3" "$radio1$radio2$radio0"]]
  unset radio1 radio2 radio0 checked checkedresult
  puts $chan [tr "" [td "" ""] [td "" "Channel: "] [td "COLSPAN=2" [html_form_select "guide(op_chan)\" STYLE=\"font-size:11px" $chanvals $chanlabs $guide(op_chan)]] [td "" ""]]
  puts $chan [tr "" [td "" ""] [td "" "Custom channels:"] [td "COLSPAN=3" [html_form_text 1 50 "guide(op_chan_cust)\" STYLE=\"font-size:11px" $guide(op_chan_cust)]]]

  puts $chan [tr "" [td "COLSPAN=5" "[html_table_start "STYLE=font-size:11px" "" ""]$datesrch[td "" [html_form_input "submit" "submit" "Submit"]][html_table_end]"]]

  puts $chan [tr "" [td "COLSPAN=5 ALIGN=CENTER" [html_form_input "submit" "submit" "Save"] ]]

  puts $chan [html_table_end]
  puts $chan [html_form_end]

