<?xml version='1.0' encoding='utf-8' ?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:variable name="title" select="/rss/channel/title"/>
<xsl:variable name="proglink" select="/rss/channel/link"/>
	<xsl:template match="/">
	<html>
	<head>
	<title>
<xsl:value-of select="$title"/>
 RSS Feed
</title>
	<style type="text/css">

* { margin:0;padding:0;}
body{background-color:#fff;border:0px;margin:10px;font-family:Verdana,Arial,Helvetica,sans-serif,"MS sans serif";font-size:80%;font-weight:normal;color:#0000;}
h2{margin:0px;padding:5px 0px;font-size:140%;}
p{margin:0px;padding:5px 0px;}

#header{ border:1px solid red; padding:10px; margin: 0 0 20px 0; width:800px; }

#description{ border:1px solid #CBCCDA;; padding:10px; margin: 0 0 0px 0; width:460px; background-color:#efc;}
div.showlist{margin-top:-1px; border:1px solid #CBCCDA; padding-bottom:6px;margin-bottom:10px;}
div.showlist{width: 480px; background-color:#efc; }
div.showlist h3{font-size:1.2em;padding:9px 9px 7px 9px; color:#8b4;}
div.showlist p{padding:0 0 6px 9px;color:#666;}
div.showlist dl{border-top:1px solid #CBCCDA;color:#666;padding-top:6px;}
div.showlist dt{margin:10px 5px 0px 73px;text-indent:-73px;}
div.showlist dt em{padding:0 3px 0 8px;font-style:normal;}
div.showlist dt span{position:absolute;left:-2000px;}
div.showlist dt a{color:#8b4; margin:0 3px 0 20px;padding:0 0 0 3px;font-weight:bold;color:#c00;}
div.showlist dd{border-bottom:1px dotted #D5D5D3;margin:0 10px 0 0;padding:2px 0 10px 60px;}

div.right {position:absolute; left:510px; width:290px; padding: 20px 30px; }
div.right h2{font-size:1.2em;padding:2px; color:#8b4;}
div.right  ul {list-style-type:disc;margin:0px 20px;}
div.right  li {padding:5px 0px;}
</style>
</head>
<xsl:apply-templates select="rss/channel"/>
</html>
</xsl:template>
	<xsl:template match="channel">
	<body>
	<div id="header">
<h2>What is this page?</h2>
	<p>
This is an RSS feed from TivoWebPlus. RSS allows you to check
shows from your desktop without having to come to this website.
</p>
</div>
	<div class="right">
<h2>How to subscribe to this feed</h2>
	<p>
You can subscribe to this feed in a number of ways:
</p>
	<ul>
	<li>
Drag 
<a href="">this link</a>
 into your RSS Reader software.
</li>
<li>Drag the URL of the feed into your feed reader.</li>
	<li>
Cut and paste the URL of the feed into your feed reader.
</li>
</ul>
</div>
<!-- div id="description">
	</div -->
	<div class="content">
	<div class="left">
<xsl:variable name="C" select="count(/rss/channel/item)"/>
	<div class="showlist">
	<h3>
	<a href="{link}">
<xsl:value-of select="$title"/>
</a>
</h3>
	<p>
	<xsl:choose>
<xsl:when test="$C = 0">There are no items </xsl:when>
<xsl:when test="$C = 1">There is only 1 item </xsl:when>
	<xsl:otherwise>
There are 
<xsl:value-of select="$C"/>
 items 
</xsl:otherwise>
</xsl:choose>

				  currently in this feed
</p>
	<dl class="audio">
<xsl:apply-templates select="item"/>
</dl>
</div>
</div>
</div>
	<div id="footer">
	<p>
All content is copyright 
<xsl:value-of select="/rss/channel/copyright"/>
</p>
</div>
</body>
</xsl:template>
	<xsl:template match="item">
<xsl:variable name="url" select="enclosure"/>
	<dt>
	<a class="item" href="{link}">
<xsl:value-of select="title"/>
-
<xsl:value-of select="pubDate"/>
</a>
</dt>
	<dd>
<xsl:value-of select="description" />
</dd>
</xsl:template>
</xsl:stylesheet>
