#!/tvbin/tivosh

setpri fifo 1

lappend auto_path $tcl_library/tv

source $tcl_library/tv/Inc.itcl
tvsource $tcl_library/tv/EndPoint.itcl
tvsource $tcl_library/tv/SwSystem.itcl
tvsource $tcl_library/tv/Database.itcl
tvsource $tcl_library/tv/mfslib.tcl
tvsource $tcl_library/tv/Setup.itcl

namespace import Inc::*

set file [lindex $argv 0]
set id [lindex $argv 1]

set db [dbopen]
dbload $db $file
if { [llength $id] > 0 } {
   dumpobj /Server/$id
}

# update the clock to prevent "clock is warped" message from stopping index
# These are all commented out. You don't really need to do this from dbload anyway
### Alternative 1 - Not suitable for ozTiVo
# putlog "processing timeService: ntpdate - dbload30"
# /bin/ntpdate -b 204.176.49.10 240.176.49.11
# set cmdStr [CmdStr cms#auto]


### Alternative 2 if running dumbntpd
# putlog "processing timeService: ntpdate - dbload30"
# $cmdStr setCmd "/bin/ntpdate -u -b -p 1 127.0.0.1"
# $cmdStr process foo

### Alternative 3 
# exec /tivo-bin/touch /var/timestamp
# Now really set the time to a local server
# exec /tvbin/settime `rtime x.x.x.x 36000`

# Tell MyWorld that there is new program data.
event send $TmkEvent::EVT_DATA_CHANGED $TmkDataChanged::PROGRAM_GUIDE 0
