#!/tvbin/tivosh
EnableTransactionHoldoff True
set dbPoolSize [expr 300 * 1024]

set db [dbopen $dbPoolSize]

set file1 "channels.tmp2"
set output [open $file1 "w"]


ForeachMfsFile fsid name type "/Headend" "" {
 RetryTransaction {
   set headend [db $db openid $fsid]
   set lineups [dbobj $headend get Lineup]
   set headendname [dbobj $headend get Name]
   set headendtmsid [dbobj $headend get TmsHeadendId]
   set headendstate [dbobj $headend get State]
   set headendpostalcode [dbobj $headend get PostalCode]
   set headendlocation [dbobj $headend get Location]
   set headendserverid [dbobj $headend get ServerId]

   foreach lineup $lineups {

      set lineupname [dbobj $lineup get Name]
      set lineuptype [dbobj $lineup get Type]
      set channelslist [dbobj $lineup gettarget Channel]
      
      foreach channel $channelslist {
        puts $output "{$channel \{$lineupname,$lineuptype,$headendname,$headendtmsid,$headendstate,$headendpostalcode,$headendlocation,$headendserverid}\} "
         
         }
      }
   }
}
close $output



puts "Here goes..."
set file "channels.txt"
set output [open $file "w"]
set input [open $file1 "r"]
puts $output "ServerId,Number,CallSign,Name,TmsId,Country],Affiliation,DmaNum,AffiliationIndex,ServiceTier,lineupname,lineuptype,headendname,headendtmsid,headendstate,headendpostalcode,headendlocation,headendserverid"
set count 0
while {[gets $input channel] >= 0} {
 #puts "from file: $channel"
      set firstbit [lindex [lindex $channel 0] 0]
      #puts "firstbit: $firstbit"
      regexp {([0-9]*)/(.*)} $firstbit junk id subid
       RetryTransaction {
      set chanobj [db $db openidconstruction $id $subid]
      set statobj [dbobj $chanobj get Station]
      set name [dbobj $statobj get Name]
      regsub -all "," $name " " name
         puts $output "[dbobj $statobj get ServerId],[dbobj $chanobj get Number],[dbobj $statobj get CallSign],$name,[dbobj $statobj get TmsId],[dbobj $statobj get Country],[dbobj $statobj get Affiliation],[dbobj $statobj get DmaNum],[dbobj $statobj get AffiliationIndex],[dbobj $chanobj get ServiceTier],[lindex [lindex $channel 0] 1]"
         incr count
         if {[expr $count % 50] == 0} {
            puts "."
            puts -nonewline "$count "
         } else {
            puts -nonewline "."
         }
         
      }
   
}
puts ""
close $input
close $output
dbclose $db

  puts "Finished getting data" 