#!/tvbin/tivosh
#
#                 timezoneadj.tcl for UK TiVo 2.5.5 - healeydave
#
#
# Credits
#     timezoneadj.tcl is based on AdjustTimeZone30 for Tivo OS 3.0 which intern
#     was based on AdjustTimeZone - 2.5.1 by Andrew Palm.
#     Neither script worked on my UK Tivo 2.5.5, hence this version with minor
#     modifictions.
#
#     Although you can choose from the list of TimeZones, you should use 7 for
#     the UKTiVo Alternative EPG Project.

source /tvlib/tcl/tv/DbEnum.tcl

    puts "Hawaii ${TimeZone::Hawaii}"
    puts "Alaska ${TimeZone::Alaska}"
    puts "Pacific ${TimeZone::Pacific}"
    puts "Mountain ${TimeZone::Mountain}"
    puts "Central ${TimeZone::Central}"
    puts "Eastern ${TimeZone::Eastern}"
    puts "GMT-1 ${TimeZone::GMTMinus1}"
    puts "GMT-11 ${TimeZone::GMTMinus11}"
    puts "GMT-12 ${TimeZone::GMTMinus12}"
    puts "GMT-2 ${TimeZone::GMTMinus2}"
    puts "GMT-3 ${TimeZone::GMTMinus3}"
    puts "GMT-4 ${TimeZone::GMTMinus4}"
    puts "GMT+2 ${TimeZone::GMTPlus2}"
    puts "GMT+3 ${TimeZone::GMTPlus3}"
    puts "GMT+4 ${TimeZone::GMTPlus4}"
    puts "GMT+5 ${TimeZone::GMTPlus5}"
    puts "GMT+6 ${TimeZone::GMTPlus6}"
    puts "GMT+7 ${TimeZone::GMTPlus7}"
    puts "GMT+8 ${TimeZone::GMTPlus8}"
    puts "GMT+9 ${TimeZone::GMTPlus9}"
    puts "GMT ${TimeZone::GMT}"
    puts "GMT+1 (w-Europe) ${TimeZone::GMTPlus1}"
    puts "GMT+10 ${TimeZone::GMTPlus10}"
    puts "GMT+11 ${TimeZone::GMTPlus11}"
    puts "GMT+12 ${TimeZone::GMTPlus12}"

# get new time zone, adjust if not blank or not -
puts "Enter new Time Zone (use 7 for the UKTiVo Alternative EPG Project)"
gets stdin tzNew
if { $tzNew != "-" && $tzNew != ""   } {

  set db [dbopen]
  RetryTransaction {
    set config [db $db open /Setup]
    set tzOld [dbobj $config get TimeZone]
    dbobj $config set TimeZone $tzNew
    set tzNew [dbobj $config get TimeZone]
    puts "TimeZone was $tzOld now set to $tzNew"

    # DayLightSavings 
      #dbobj $config set DaylightSavingsPolicy 2

  }
  dbclose $db
  unset db
# See /tvlib/tcl/tv/Inc.itcl for a list of these enums.
  event send $TmkEvent::EVT_DATA_CHANGED $TmkDataChanged::RECORDINGS_ON_DISK 0
  puts "Done, please restart Tivo for changes to take effect."
}

