#!/tvbin/tivosh
#
# Create a Line-In Source
# (c) 2000, Ricky Beam [cramer]
#
# "If you break it, you own all the peices."
#
source $tcl_library/tv/Inc.itcl
source $tcl_library/tv/mfslib.tcl


set db [dbopen]
transaction {

  set setup [db $db open /Setup]

# Create a Station Reference for the channel menu(s)
  puts "Creating Station: A/V"
  set station [db $db create Station]
  dbobj $station set CallSign "A/V"
  dbobj $station set Name "Composite Input"
  dbobj $station set Affiliation TiVo

# [here's the Real Magic(tm)]
#
# Create a new Input SignalSource
# -- SignalType 5 == CableBox 
#
# -- Connector 3 == Composite In 
# -- Connector 5 == S-Video In 
#
# (LineupType is an attempt to make dynlineup.tcl shut up
#  but it needs a Headend to be happy, so screw it.)
#
  puts "Creating SignalSource A/V"
  set source [db $db createsub SignalSource $setup]
  dbobj $source set ProviderName "TiVo Composite Input"
  dbobj $source set SignalType 5
  dbobj $source set Connector 3
#  dbobj $source set RFChannel 2
  dbobj $source set CableBoxCodeNum 30001 # look in /hack/guide/stb for code list
# dbobj $source set LineupType 0
  dbobj $source set VariableBitrate 0
  dbobj $source set RecieverNumDigits 3
  dbobj $source set TunerDigitDelay 150
  dbobj $source set UnattendedTunerDigitDelay 800
  dbobj $source set DBSRemoteMethod 2
  dbobj $setup add Source $source
#
}
dbclose $db
unset db

event send 23 16 0
puts "Done"

puts "If the new input isn't available, REBOOT your Tivo."
sync
