#!/tvbin/tivosh
##############################################################################
# mfs_ftp - Copyright (C) 2001-2003  Riley Cassel<RC3105@dealdatabase.net>
# This program is distributed in the hope that it will be useful
# but WITHOUT ANY WARRANTY.  without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# this script coordinates data between serveral support binaries released 
# under GPL licenses, but this script itself IS NOT under the gpl license
# This is a basic tivo ftp video server to extract/insert recordings
# TERMS OF USE: personal (noncommercial) fair-use backup & restore
# This software may not be used for copywright infringment or any illegal 
# purpose, bundled with any product, sold, distributed or redistributed 
# under any circumstances on any media without express written consent.
##############################################################################
proc init_vars { } {
global info argv control_socket db resume
set info(version) "1.2.9p"
set info(ithrottle) 3
set info(insert_priority) 10
set info(dbl) 0
set info(multithreaded) 0
set info(saveuntil) suggestion
set info(name_detail) 5
set info(bjuggle) 0
set info(active) 0
set info(ac_interval) 1800
set resume(e) 1
set info(gatewayip) "127.0.0.1" ; set info(gatewayport) "3105"
# end of user definable paramaters
set info(path) [file dirname [info script]]
set info(tzoffset) 0
set resume(s) 0
if { $info(multithreaded) == 1 } { set info(insert_priority) 1 }
if { [lindex $argv 0] == "" } { set info(port) 3105 } else { set info(port) [lindex $argv 0] }
set info(background) [lindex $argv 1]
set info(localip) "127,0,0,1" ; set info(type) "I"
set info(update_last) [clock seconds] ; set info(cached_rec_fsids) "0"
if { $info(ithrottle) > 10 } { set info(ithrottle) 10 }
if { $info(ithrottle) < -1 } { set info(ithrottle) -1 }
set info(ithrottlems) [expr $info(ithrottle) * 5]
set info(ty+) "################################"
append info(ty+) $info(ty+); append info(ty+) $info(ty+);
append info(ty+) $info(ty+); append info(ty+) $info(ty+);
set info(bmfsid) 0
}

proc init_procs { } {
global info
background
set patchfiles "settings hmo vobtools drdos patches p1 p2 p3 p4"
foreach file $patchfiles { if { [file exist $info(path)/$file.tcl] } { source $info(path)/$file.tcl ; outd -1 "sourcing $file" } }
versioncheck
get_tzoffset
catch { file rename $info(path)/abort.txt $info(path)/abort.doc }
ping_pong
build_dir_root
update_rec_fsids 1
prune_cache
reset_control_socket
#event register $TmkEvent::EVT_DATA_CHANGED datachanged
}

proc CDUP { fsock } {
global info
outd 2 "CDUP"
 set info(dir) "/"
 tee $fsock "250 Directory change successful."
}

proc close_shave { fsid {print 0} } {
global db ; set p 2
 if { $print == 1 || $info(dbl) >= $p } { puts "shearing recobj $fsid" }
    RetryTransaction {
	set obj [db $db openid $fsid]
	if { [dbobj $obj type] == "Recording" } { catch { dbobj $obj remove Part } }
    }
}

proc DELE { fsock line } {
global info db ; set p 1
 outd $p "$line"
 set line "[string range $line 5 end]"
 set recfsid [lindex [fsid_from_filename $line] 0]
 if { $recfsid  == -1 } {
	tee $fsock "550 error, can't find \"[string range $line 5 end]\""
 } else {
  RetryTransaction {
    set rec [db $db openid $recfsid] ; set state [dbobj $rec get State]
    switch $state {
	3 {	dbobj $rec set CancelReason 12
		dbobj $rec set DeletionDate [expr [clock seconds] / 86400]
		dbobj $rec set DeletionTime [expr [clock seconds] % 86400]
		dbobj $rec set ErrorString "deleted via mfs_ftp"
		dbobj $rec set State 5 }
	4 {	dbobj $rec set CancelReason 12
		dbobj $rec set DeletionDate [expr [clock seconds] / 86400]
		dbobj $rec set DeletionTime [expr [clock seconds] % 86400]
		dbobj $rec set ErrorString "deleted via mfs_ftp"
		dbobj $rec set State 5 }
	5 {	dbobj $rec remove CancelReason
		dbobj $rec remove DeletionDate
		dbobj $rec remove DeletionTime
		dbobj $rec remove ErrorString
		dbobj $rec set State 4 }
    }
    catch { foreach item [array names info $recfsid*] { unset info($item) } }
  }
  outd $p "state was $state"
  tee $fsock "250 DELE command successful."
  catch { file delete $info(path)/cache/$recfsid.pts }
  update_rec_fsids 1
 }
}

proc CWD { args fsock } {
global info
 set nwd [lindex $args 1]
 set nwd [strim $nwd]
    switch $nwd {
	phoenix { after 500 phoenix_mfs_ftp stdout ChangeWorkingDirectory }
	txt	{ set info(dir) "txt" }
	asx	{ set info(dir) "asx" }
	bat	{ set info(dir) "bat" }
	tmf	{ set info(dir) "tmf" }
	shutdown { after 500 exitproc stdout ChangeWorkingDirectory }
	tyx	{ set info(dir) "tyx" }
	xml	{ set info(dir) "xml" }
	ty+	{ set info(dir) "ty+" }
	ty	{ set info(dir) "ty" }
	sps	{ set info(dir) "sps" }
	/	{ set info(dir) "/" }
	default { set info(dir) "/" }
    }
 tee $fsock "250 Directory change successful."
}

proc NLST	{ line fsock } {
global info ; set p 1
 outd $p "NLIST: \"$line\" (\"\" == LIST command)"
 tee $fsock "150 Opening ASCII mode data connection for file list."
 set list_type [lindex $line 0]
 outd $p "list_type is \"$list_type\""
 if { $info(dir) == "/" } {
    if {$list_type == "LIST"} { set listings $info(dir_list) } else { set listings $info(dir_nlst) }
 } else {
    update_rec_fsids 1
    set info(list) ""
    if {$list_type == "LIST"} { set matchstr "" } else { set matchstr [string range $line 5 end] }
    foreach fsid $info(rec_fsids) {
     if { [lsearch "3 4 5" $info($fsid,State)] != -1 } {
      if { [get_size $fsid] > 0 || [lsearch "3 4" $info($fsid,State)] != -1 } {
       if { [regexp -nocase $matchstr $info($fsid,rec_filename)] } {
	    switch $info(dir) {
bat { set SFS 128 }
asx { set SFS 512 }
xml { set SFS 2048 ; catch { set SFS [file size $info(path)/cache/$fsid.xml]}}
txt { set SFS 2048 ; catch { set SFS [file size $info(path)/cache/$fsid.xml]}}
default { set SFS $info($fsid,SFS) }
	    }
	    if { $list_type == "LIST" } {
set temp "-rwxr-xr-x   1 0        0     $SFS $info($fsid,ldate) $info($fsid,rec_filename).$info(dir)\r\n"
	    } else {
	    	set temp "$info($fsid,rec_filename).$info(dir)\r\n"
	    }
	    append temp $info(list); set info(list) $temp
       }
      }
     }
    }
    set listings $info(list)
 }
 puts -nonewline $info(dc) $listings ; catch { close $info(dc) } errval
 tee $fsock "226 Transfer complete."
}

proc datachanged 	{ type subtype } {
global info ; set p 3
outd 0 "entering datachanged - \"$type $subtype\" data change event"
#"2 3 4" == new recording, rebuild needed
  switch $subtype {
	2	{ update_rec_fsids 1 }
	3	{ update_rec_fsids 1 }
	4	{ update_rec_fsids 1 }
	default	{ }
  }
}

proc update_rec_fsids { {force 0} } {
global info db ; set p 1
outd $p "update_rec_fsids: forced $force"
 set info(rec_fsids) "" ; set info(update_last) [clock seconds]
 ForeachMfsFile fsid name type "$info(mfspath)" "" {
  RetryTransaction { set rec [db $db openid $fsid] ; set State [dbobj $rec get State] }
  if { [lsearch "3 4 5" $State] != -1 } { lappend info(rec_fsids) $fsid  ; set info($fsid,newstate) $State }
 }
 if { $info(rec_fsids) != $info(cached_rec_fsids) || [info exist info(rip)] || $force == 1 } {
  if { [info exist info(rip)] } { unset info(rip) }
  outd -1 "updating cached recording info"
  foreach fsid $info(cached_rec_fsids) { if { [lsearch -exact $info(rec_fsids) $fsid] == -1 } { foreach item [array names info $fsid*] { unset info($item) } } }
  foreach fsid $info(rec_fsids) {
    puts -nonewline stdout "." ; flush stdout
    if { [info exist info($fsid,State)] == 0 } {
	outd 3 "no $fsid state - force update"
	rec_info_from_db $fsid
    } else { 
	if { $info($fsid,State) == 3 || $info($fsid,State) != $info($fsid,newstate) } { rec_info_from_db $fsid }
    }
  }
  set info(cached_rec_fsids) $info(rec_fsids)
  puts stdout "\n" ; flush stdout ; build_rec_filenames
 } else { outd $p "no update necesary" }
}

proc rec_info_from_db { fsid } {
global info db ; set p 3
 outd $p "rec_info_from_db: recobj\{$fsid\}"
 set tsize 0 ; set info($fsid,sizes) "" ; set file_size 0 ; set info($fsid,parts) "" ; set info($fsid,OAD) 0
 RetryTransaction {
  set rec [db $db openid $fsid]
  foreach item "State Showing Part" { set info($fsid,$item) [ntrim [dbobj $rec get $item]] }
  foreach item "Date Time Program Station" { set info($fsid,$item) [ntrim [dbobj $info($fsid,Showing) get $item]] }
  foreach item "Title EpisodeTitle OriginalAirDate" { set info($fsid,$item) [ntrim [dbobj $info($fsid,Program) get $item]] }
  if { $info($fsid,OriginalAirDate) != "" } { set info($fsid,OAD) $info($fsid,OriginalAirDate) }
  set info($fsid,CallSign) [dbobj $info($fsid,Station) get CallSign]
  foreach part $info($fsid,Part) { lappend info($fsid,parts) [dbobj $part get File] }
  foreach part $info($fsid,parts) {
   if { [catch { mfs streamsize $part } p_s ] } { set psize [mfs_stream_size $part] } else { set psize [expr [lindex $p_s 1] * [lindex $p_s 0]] }
   lappend info($fsid,sizes) $psize
   set tsize [expr "$tsize" + "$psize.0"]
  }
  set tsize [string range $tsize 0 [expr [string first "." $tsize] -1]]
  set info($fsid,StreamFileSize) "$tsize"
  outd $p "$info($fsid,Title) $tsize k"
 }
 cache_xml_2_disk $fsid
 calc_tertiary_info $fsid
}

proc calc_tertiary_info	{ fsid } {
global info db ; set p 2
 outd $p "calc_tertiary_info: recobj\{$fsid\}"
 if { [info exists info($fsid,State)] == 0 } { rec_info_from_db $fsid }
 set recsec [expr $info($fsid,Date) * 86400 + $info($fsid,Time) + $info(tzoffset)]
 set info($fsid,date) [clock format $recsec -format "%2m-%2d-%y  %I:%2M%p" ]
 set info($fsid,ldate) [clock format $recsec -format "%b %2d %I:%2M" ]
 if { [expr [clock seconds] + $info(tzoffset) - $recsec ] > 31449600 } { set info($fsid,ldate) [clock format $recsec -format "%b %2d  %Y"] }
 set recdate "[clock format $recsec -format "%I.%M %p %a %b %d, %Y"]"
 set oad "[clock format [expr $info($fsid,OAD) * 86400] -format "%Y-%m-%d"]"
 set info($fsid,SFS) "[string range "000000000000" 0 [expr 11 - [string length $info($fsid,StreamFileSize)]]]$info($fsid,StreamFileSize)"
 switch $info($fsid,State) {
	3 { set S "\{ Recording\}" ; set info(rip) 1 }
	5 { set S "\{ Deleted\}" }
	6 { set S "\{ Pending\}" }
	default { set S "" }
 }
 switch $info(name_detail) {
  0 { set info($fsid,rec_filename) "$S$fsid" }
  1 { set info($fsid,rec_filename) "$S$fsid - $info($fsid,Title) - $info($fsid,EpisodeTitle)" }
  2 { set info($fsid,rec_filename) "$S$info($fsid,Title) - $info($fsid,EpisodeTitle)" }
  3 { set info($fsid,rec_filename) "$S\{$info($fsid,Title)\}\{$info($fsid,EpisodeTitle)\}\{$info($fsid,CallSign)\}" }
  4 { set info($fsid,rec_filename) "$S\{$info($fsid,Title)\}\{$oad\}\{$info($fsid,EpisodeTitle)\}\{\}\{$info($fsid,CallSign)\}" }
  5 { set info($fsid,rec_filename) "$S\{$info($fsid,Title)\}\{$oad\}\{$info($fsid,EpisodeTitle)\}\{$recdate\}\{$info($fsid,CallSign)\}" }
  6 { set info($fsid,rec_filename) "$S\{$info($fsid,Title)\}\{$oad\}\{$info($fsid,EpisodeTitle)\}\{$recdate\}\{$info($fsid,CallSign)\}\{$fsid\}" }
  X { 	set tlen [string length $info($fsid,Title)]
	set Title "[string range $info($fsid,Title) 0 25]"
	set etlen [expr 33 - $tlen]
	set ETitle $info($fsid,EpisodeTitle)
	if { $ETitle == "" } {
	 set oad "[clock format [expr $info($fsid,OAD) * 86400] -format "%y-%m-%d"]"
	 set recdate "[clock format $recsec -format "%m-%d-%y"]"
	 set ETitle "$oad $recdate"
	}
	set ETitle "[string range $ETitle 0 $etlen]"
	set info($fsid,rec_filename) "$S\{$Title\}\{$ETitle\}"
    }
 }
 set temp_attrs "StreamFileSize State ldate rec_filename parts SFS sizes"
 foreach item $temp_attrs { set temp($item) $info($fsid,$item) }
 foreach item [array names info $fsid*] { unset info($item) }
 foreach item $temp_attrs { set info($fsid,$item) $temp($item) }
}

proc build_rec_filenames { } {
global info
outd 1 "build_rec_filenames:"
 set info(rec_filenames) ""
 foreach fsid $info(rec_fsids) {
	puts -nonewline stdout "."; flush stdout
	lappend info(rec_filenames) "$info($fsid,rec_filename)"
 }
 puts stdout "\n"; flush stdout
}

proc mfs_stream_size { fsid } {
global info
 set inf [open "|$info(path)/mfs_stream -s $fsid 2>/dev/null " r]
 fconfigure $inf -translation binary
 set mc [string range [read $inf 16] 12 15]
 catch { close $inf } ev
 binary scan $mc H* charb
 set chunks [expr ((0x$charb - 4) / 256) + 1 ]
 return [expr $chunks * 131072]
}

proc cache_xml_2_disk { fsid {force 0} } {
global info db ; set p 3
outd 2 "cache_xml_2_disk: recobj\{$fsid\}  force cache = \"$force\""
if { $force == 1 } {
 outd $p "deleting cached into if it exists"
 catch { unset info($fsid,dcached) }
 catch { [file delete $info(path)/cache/$fsid.xml] }
 catch { [file delete $info(path)/cache/$fsid.pts] }
 after 50
}
 if { $info($fsid,State) == 3 } { outd 1 "recording in progress, don't cache $fsid.xml yet" ; return }
 if { [info exists info($fsid,dcached)] == 0 } { set info($fsid,dcached) [file exist $info(path)/cache/$fsid.xml] }
 if { $info($fsid,dcached) == 1 } { outd $p "allready cached $fsid.xml" ; return }
 outd $p "caching xml & pts data for recobj $fsid"
 RetryTransaction { set xml "[dump_xml [db $db openid $fsid]]" }
 catch_var $xml $info(path)/cache/$fsid.xml
 catch_var $info($fsid,parts) $info(path)/cache/$fsid.pts
 after 50
}

proc prune_cache { } {
global info db
 outd 1 "pruning obsolete entries from $info(path)/cache/"
 set temp_list ""
 catch { set temp_list [glob $info(path)/cache/*] }
 if { [info exist $temp_list] == -1 } { set temp_list "" }
 foreach file $temp_list {
  after 10
  set fsid [file tail $file] ; set fsid [file root $fsid]
  if { [lsearch -exact $info(rec_fsids) $fsid] == -1 } { file delete "$file" }
 }
 outd 2 "prune_cache complete"
}

proc NOOP	{ args fsock } {
tee $fsock "200 Command okay."
}

proc PASS	{ fsock line } {
outd 1 "PASS: \"[string range $line 5 end]\""
tee $fsock "230 Running in TiVo Mode."
}

proc PWD	{ args fsock } {
global info
outd 2 "PWD:"
set option1 [lindex $args 1]
 if { $info(dir) == "/" } { tee $fsock "257 \"$info(dir)\" is current directory." 
 } else { tee $fsock "257 \"/$info(dir)\" is current directory." }
}

proc QUIT	{ fsock } {
global info
 tee $fsock "221 Server Closing Control Connection by client request"
 after 1 reset_control_socket
}

proc fsid_from_filename { line } {
global info ; set p 3
 outd 2 "fsid_from_filename:\n\"$line\""
 set suffix "[string range $line [expr [string last . $line] + 1] end]"
 set temp [file tail [file root $line]]
 outd $p "searching \$info(rec_filenames) for \n\"$temp\""
 set fsid [lsearch -exact $info(rec_filenames) $temp]
 if { $fsid != -1 } {
	set fsid "[lindex $info(rec_fsids) $fsid]"
	outd $p "filename matches fsid \"$fsid\""
 } else {
	outd $p "searching fsid list for \"$temp\""
	set fsid [lsearch -exact $info(rec_fsids) $temp]
	if { $fsid != -1 } {
	 outd $p "found filename in fsid list"
	 set fsid "[lindex $info(rec_fsids) $fsid]"
	}
 }
 return "$fsid $suffix"
}

proc build_dir_root { } {
global info
 set root_dir "tmf ty ty+ xml txt bat asx";
 if { [file exist $info(path)/at] } { lappend root_dir "tyx" }
 foreach list "dir_list dir_nlist" { set info($list) "" }
 foreach dir $root_dir { append info(dir_nlst) "$dir\r\n"}
 foreach dir $root_dir { append info(dir_list) "dr--r--r--   1 0        0            1024 Jan 01  1972 $dir\r\n" }
 append info(dir_list) "-r--r--r--   1 0        0        0 May 31 19:00 phoenix.txt\r\n"
 append info(dir_nlst) "phoenix.txt\r\n"
 append info(dir_list) "-r--r--r--   1 0        0        0 May 31 19:00 shutdown.txt\r\n"
 append info(dir_nlst) "shutdown.txt\r\n"
}

proc get_xml { recfsid } {
global info db ; set p 3
outd 2 "get_xml: recobj\{$recfsid\}"
 if { [file exist $info(path)/cache/$recfsid.xml] && 1 == 1 } {
	outd $p "reading xml from disk cache"
	set info(xml) [catvar $info(path)/cache/$recfsid.xml]
 } else {
	outd $p "getting xml from db"
	RetryTransaction { 
		set rec [db $db openid $recfsid]
		set info(xml) "[dump_xml $rec]" 
	}
 }
}

proc REST { fsock line } {
global info resume ; set p 1
 outd $p "REST: \"[string range $line 5 end]\""
 if { $resume(e) == 0 } {
  tee $fsock "502 Command not implemented \"$line\""
 } else {
 tee $fsock "350 Restart okay, awaiting file request."
 set resume(s) [lindex $line 1]
 outd $p "resume(s) == \"$resume(s)\""
 }
}

proc RETR { fsock line } {
global info db control_socket resume ; set p 2
 set line [string range $line 5 end]
 outd 1 "RETR:\n\"$line\""
 set line [file tail $line] ; 
 set temp [fsid_from_filename $line]
 set recfsid [lindex $temp 0] ; set filetype [lindex $temp 1]
 outd $p "recfsid \"$recfsid\" filetype \"$filetype\""
 if { $line == "shutdown.txt" } { after 500 exitproc stdout RETR }
 if { $line == "phoenix.txt"} { after 500 phoenix_mfs_ftp stdout RETR }
 if { [lsearch -exact "tmf ty ty+ tyx sps" "$filetype"] != -1 } { }
 if { $recfsid == -1 } {
	tee $fsock "550 error, can't find \"$line\"" ; 
	catch { close $info(dc) }
	return
 }
 spawn $filetype
 tee $fsock "150 About to open data connection."
 rec_info_from_db $recfsid
 if { $info($recfsid,State) == 3 } { tee $fsock "550 error, can't extract a recording in progress" ; catch { close $info(dc) } ; return }
 build_parts_list $recfsid $resume(s)
 get_xml $recfsid
 switch $filetype {
  asx   { stream_asx $recfsid }
  bat   { stream_bat $recfsid }
  txt	{ stream_text $recfsid }
  xml	{ puts -nonewline $info(dc) $info(xml) }
  ty+	{ buildty $recfsid }
  tyx   { buildty $recfsid }
  ty	{ buildty $recfsid }
  tmf	{ stream_tmf $recfsid $info($recfsid,parts) }
  default { tee $fsock "550 error, can't find \"$line\"" }
 };#end of switch
 catch { unset info(xml) }
 catch { close $info(dc) }
 tee $fsock "226 Transfer complete."
 abortcheck "RETR"
}

proc stream_text { recfsid } {
global info
 parse_xml $info(xml)
 build_txt_from_xml $recfsid
 puts -nonewline $info(dc) "$info(txt)\n<EncapsulateXML>\n$info(xml)\n</EncapsulateXML>"
 catch { unset info(txt) }
 catch { close $info(dc) } errval
 outd 1 "stream_text: catch close info(dc) \"$errval\""
}

proc stream_asx { recfsid } {
global info
# parse_xml $info(xml)
 build_asx_from_xml $recfsid
 puts -nonewline $info(dc) "$info(txt)\n"
 catch { unset info(txt) }
 catch { close $info(dc) } errval
 outd 1 "stream_text: catch close info(dc) \"$errval\""
}

proc build_asx_from_xml { fsid } {
global info ; set p 1
 outd $p "build_asx_from_xml: recobj\{$fsid\}"
 regsub -all \\, $info(localip) . localip
 set info(txt) "<ASX version = \"3.0\">\n"
 append info(txt) "<TITLE>basic ASX file, generated by mfs_ftp</TITLE>\n"
 append info(txt) "  <ENTRY>\n"
 append info(txt) "    <Title>$info($fsid,rec_filename) [expr $info($fsid,StreamFileSize) / 1048576] Meg</TITLE>\n"
 append info(txt) "    <AUTHOR>tivo recording</AUTHOR>\n"
 append info(txt) "      <REF HREF = \"tivo://$localip/$fsid\" />\n"
 append info(txt) "  </ENTRY>\n"
 append info(txt) "</ASX>\n"
}

proc stream_bat { recfsid } {
global info
# parse_xml $info(xml)
 build_bat_from_xml $recfsid
 puts -nonewline $info(dc) "$info(txt)"
 catch { unset info(txt) }
 catch { close $info(dc) } errval
 outd 1 "stream_text: catch close info(dc) \"$errval\""
}

proc build_bat_from_xml { fsid } {
global info ; set p 1
 outd $p "build_bat_from_xml: recobj\{$fsid\}"
 regsub -all \\, $info(localip) . localip
 set info(txt) "mplayer -cache 8192 tivo://$localip/$fsid"
}

proc stream_tmf { fsid parts } {
global info
outd 2 "stream_tmf: recobj\{$fsid\}"
set stime [expr [clock seconds]]
set pout [open "|$info(path)/mfs_tarstream -x -s $parts >@$info(dc) 2>/dev/null " w]
fconfigure $pout -translation binary ; fconfigure $info(dc) -translation binary
setpri 1 $pout 1 ; puts -nonewline $pout $info(xml); close $pout
set etime [expr [clock seconds] - $stime]
set dr "[expr $info($fsid,StreamFileSize) / $etime / 1024]k/sec"
outd 1 "streamed \"$info($fsid,StreamFileSize)\" bytes in \"$etime\" seconds - \"$dr\""
}

proc buildty { recfsid } {
global db info resume ; set p 1
outd 1 "buildty:  streaming recobj\{$recfsid\} to data channel \{$info(dc)\}"
 fconfigure $info(dc) -translation binary
 setpri 1 $info(dc) 1
 set j [llength $resume(parts)]
 set s $resume(s)
 for {set i 0} { $i < $j } { incr i } {
  set fsid [lindex $resume(parts) $i]
  set c [expr [lindex $resume(sizes) $i] - $s]
  if { $s != 0 && $resume(e) == 1 } {
puts "fixing to open fifo"
	set inf [open $info(path)/fifo w+] ; catch { close $inf } ;#break_fifo
	outd $p "mfs_export -s $s -c $c $fsid \$info(dc)"
	set skip_blocks [expr $s / 512] ; set ss [expr $skip_blocks * 512]
	set diff [expr $s - $ss] ; set c [expr $c + $diff]
	outd 2 "s $s\tskip_blocks $skip_blocks\tss $ss\tdiff $diff"
	outd 2 "mfs_export -s $ss -c $c $fsid \$info(dc)"
	set info(pipe) [open "|$info(path)/mfs_export -s $ss -c $c $fsid $info(path)/fifo >>& /dev/null " w]
	set resume(s) 0
	set info(fifo) [open $info(path)/fifo r]
	fconfigure $info(fifo) -translation binary -buffersize 131072
	set junk [read $info(fifo) $diff]
	data_out $c $info(dc)
	while { [eof $info(fifo)] != 1 } { set junk [read $info(fifo) 1024] ; outd 1 "flushing fifo" }
	catch { close $info(fifo) } ; catch { close $info(pipe) }
  } else {
	outd $p "mfs_stream \"$fsid\" -c $c"
	exec $info(path)/mfs_stream -s $fsid >@$info(dc) 2>/dev/null
  }
 }
 puts -nonewline $info(dc) $info(ty+)\n$info(xml)\n$info(ty+)
}

proc build_parts_list { fsid s } {
global info resume ; set p 2
 outd $p "build_parts: recobj\{$fsid\}"
 set resume(parts) $info($fsid,parts)
 set resume(sizes) $info($fsid,sizes)
 outd $p "building new lists"
 while { $s >= [lindex $resume(sizes) 0] } {
	set s [expr $s - [lindex $resume(sizes) 0]]
	set resume(sizes) [lrange $resume(sizes) 1 end]
	set resume(parts) [lrange $resume(parts) 1 end]
 }
 set resume(s) $s
 outd $p "\norig list: \{$info($fsid,parts)\}\nnew list:  \{$resume(parts)\}"
}

proc build_txt_from_xml { fsid } {
global info ; set p 1
 outd $p "build_text_from_xml: recobj\{$fsid\}"
 regsub -all \\, $info(localip) . localip
 set info(txt) "$info($fsid,rec_filename) "
 append info(txt) "[expr $info($fsid,StreamFileSize) / 1048576] Meg\n\n"
 append info(txt) "$info(Description)\n\n"
 append info(txt) "<gatewayip>$info(gatewayip)</gatewayip>\n"
 append info(txt) "<gatewayport>$info(gatewayport)</gatewayport>\n" 
 append info(txt) "<tivoip>$localip</tivoip>\n"
 append info(txt) "<tivoport>$info(port)</tivoport>\n"
 append info(txt) "<recfsid>$fsid</recfsid>\n"
 append info(txt) "<parts>$info($fsid,parts)</parts>\n"
 set existseconds [expr [clock seconds] + $info(tzoffset)]
 set tfdate "[clock format $existseconds -format "%I.%2M %p %a %b %d, %Y"]"
 append info(txt) "<existwhenseconds>$existseconds</existwhenseconds>\n"
 append info(txt) "<existwhendate>$tfdate</existwhendate>\n"
 append info(txt) "<recname>$info($fsid,rec_filename)</recname>\n"
 append info(txt) "<Description>$info(Description)</Description>\n"
 append info(txt) "<StreamFileSize>$info($fsid,StreamFileSize)</StreamFileSize>\n"
 append info(txt) "<Megabytes>[expr $info($fsid,StreamFileSize) / 1048576]</Megabytes>\n"
 set temp [clock format $info(Duration) -format "%I:%M" ]
 append info(txt) "<Duration>$temp</Duration>\n"
}

proc STOR { fsock line } {
global info control_socket
outd 1 "STOR:\n\"$line\""
 set line [string range $line 5 end]
 set line [file tail $line]
 set choplength [string last . $line]
 set filetype [string range $line [expr $choplength +1] end]
 if { [lsearch -exact "tmf ty ty+ sp" "$filetype"] != -1 } {
   if { [lsearch -exact "txt xml sp" "$filetype"] == -1 } {
    set newrecording [ make_blank_rec $line]
    rec_info_from_db $newrecording
   }
   tee $fsock "150 Opening BINARY mode data connection for \"{$line}\""
   spawn $filetype
   switch $filetype {
	tmf	{ parse_tmf $line $fsock $newrecording }
	ty	{ parse_ty+ $line $fsock $newrecording }
	ty+	{ parse_ty+ $line $fsock $newrecording }
	sp	{ store_sp $line $fsock }
	txt	{ store_txt $line $fsock }
	xml	{ store_xml $line $fsock }
	default { }
   }
 } else {
   tee $fsock "550 error, invalid file type for upload"
   catch { close $info(dc) }
 }
 update_rec_fsids
 abortcheck "STOR"
}

proc store_sp { filename fsock } {
global info
outd 1 "store_sp:\n\"$filename\""
 set outf [open "$info(path)/seasonpass/$filename" w]
 fcopy $info(dc) $outf
 catch { close $info(dc) }
 close $outf
 tee $fsock "226 File transfer complete"
 if { [file exist $info(path)/seasonpass/restore_sp.tcl] } {
  exec $info(path)/seasonpass/restore_sp.tcl "$info(path)/seasonpass/$filename" >&/dev/null &
 }
}

proc store_xml { filename fsock } {
global info
outd 1 "store_sp:\n\"$filename\""
 set outf [open "$info(path)/cache/$filename" w]
 fcopy $info(dc) $outf
 catch { close $info(dc) }
 close $outf
 tee $fsock "226 File transfer complete"
 if { 1 == 2 } {
  exec $info(path)/seasonpass/restore_sp.tcl "$info(path)/seasonpass/$filename" >&/dev/null &
 }
}

proc parse_tmf { filename fsock newrecording } {
global info ; set p 2
outd 1 "parse_tmf:"
 set info(xml) [xml_from_tmf]
 catch_var $info(xml) $info(path)/cache/$newrecording.xml
 parse_xml $info(xml)
 setrecinfo $newrecording
 foreach item "finished totalsize meg 10meg" { set info($item) 0 }
 while { [eof $info(dc)] != 1 } { tmf2fsid $newrecording }
 catch { close $info(dc) } ev
 outd $p "parse_tmf: catch close info(dc) errval \"$ev\""
 outd $p "recobj\{$newrecording\} is [expr $info(totalsize)/1024] meg" 
 tee $fsock "226 File transfer complete"
 set_rec_csos $newrecording
 finalize_rec $newrecording
 rec_info_from_db $newrecording
 cache_xml_2_disk $newrecording 1
}

proc parse_ty+ { filename fsock newrecording } {
global info ; set p 2
 outd $p "parse_ty+:"
 foreach item "finished totalsize meg 10meg" { set info($item) 0 }
 catch { unset info(xml) }
 while { [eof $info(dc)] != 1 } { ty2fsid $newrecording }
 catch { close $info(dc) }
 outd $p "recobj\{$newrecording\} is [expr $info(totalsize)/1024] meg"
 tee $fsock "226 File transfer complete"
 finalize_rec $newrecording
 if { [info exist info(xml)] } {
  catch_var $info(xml) $info(path)/cache/$newrecording.xml
  outd 4 "info(xml) exists, \n$info(xml)"
  parse_xml $info(xml)
  setrecinfo $newrecording
  }
 catch { unset info(xml) }
 rec_info_from_db $newrecording
}

proc ty2fsid { fsid } {
global info ; set p 1
outd $p "ty2fsid: fsid\{$fsid\}"
 set info(mc) [read $info(dc) 131072]
 if { [string length $info(mc)] < 131072 } {
	if { [string length $info(mc)] > 0 } { get_xml_from_chunk }
	outd 1 "end of file or invalid chunk - leaving ty2fsid"
	return
 }
 set temp [string range $info(mc) 0 4] ; outd $p "header descriptor is \"$temp\""
 if { $temp != "Fz" } { outd $p "gong! not a header" ; return }
 set plen [string range $info(mc) 12 15]
 binary scan $plen H* charb ; set chunks [expr ((0x$charb - 4) / 256) + 1 ]
 outd $p "tchl is \"$charb\" == \"$chunks\" chunks"
 set bytes [ expr $chunks * 131072 ]
 set info(totalsize) [expr $info(totalsize) + $bytes/1024]
 set newfsid [AddPart $fsid $bytes]
	if { $newfsid != -1 } {
 set outf [open "| $info(path)/mfs_stdinsert $newfsid - " w]
 fconfigure $outf -buffersize 4096 -translation binary
 fconfigure $info(dc) -buffersize 4096 -translation binary
 puts -nonewline $outf $info(mc) ; unset info(mc)
 set bytes [expr $bytes - 131072]
 data_in $bytes $outf
	}
}

proc get_xml_from_chunk { } {
global info
outd 1 "get_xml_from_chunk:"
 set temp [string range $info(mc) 0 511]
 if { $temp !=  $info(ty+) } {
	outd 1 "didn't find the starting #'s"
	return
 }
 set mc [string range $info(mc) 512 end]
 set xml_stop [string first $info(ty+) $mc]
 outd 3 "xml_stop is $xml_stop"
 set info(xml) [string range $mc 0 [expr $xml_stop -1]]
 outd 3 "$info(xml)"
 unset mc
}

proc tmf2fsid { fsid } {
global info
 outd 1 "tmf2fsid: recobj\{$fsid\}"
 set tarh [read $info(dc) 512]
 if { $info(finished) == 1 } { return }
 set nlen [expr [string first \x00 $tarh] -1]
 if { $nlen == -1 } {
	outd 2 "end of file or invalid segment - leaving tmf2fsid"
	set info(finished) 1 ; return
 } else {
	set filename [string range $tarh 0 $nlen]
	set fname4 [string range $filename 0 3]
	if { $fname4 != "part" } {
		outd 2 "end of file or invalid tarpart \"$fname4\""
		set info(finished) 1 ; return
	}
	outd 2 "starting segment \"$filename\""
 }
 set bytes [expr [string range $tarh 124 134]]
 set blocks [expr int($bytes / 512)]
 set info(totalsize) [expr $info(totalsize) + $bytes/1024]
 if { [expr $blocks * 512] < $bytes } { incr blocks }
 set pbytes [expr $blocks * 512 - $bytes]
 if { $info(bjuggle) == 1 } { bookmark_juggle $fsid }
 set newfsid [AddPart $fsid $bytes]
 set outf [open "| $info(path)/mfs_stdinsert $newfsid - " w]
 fconfigure $outf -buffersize 4096 -translation binary ; fconfigure $info(dc) -buffersize 4096 -translation binary
 data_in $bytes $outf
}

proc data_in { bytes outf } {
global info
 setpri 1 $outf $info(insert_priority)
 set stime [expr [clock seconds]-1]
 if { $info(ithrottle) < 0 } {
	outd 1 "fcopying $bytes bytes at a time - please wait"
	fcopy $info(dc) $outf -size $bytes
 } else {
  set chunksize 65536 ; set chunknum 0
   for {set i 0} {$i < $bytes} {incr i $chunksize} {
	set s [min $chunksize [expr $bytes - $i]]
	fcopy $info(dc) $outf -size $s ; if { [eof $info(dc)] == 1 } { set i $bytes }
	incr chunknum ; if { $info(ithrottlems) >= 0 } { after $info(ithrottlems) }
	set dr "[expr $chunknum * $chunksize/([clock seconds]-$stime) /1024]k/sec"
	puts -nonewline stdout "\t[expr $chunknum / 16] meg\t$dr\r" ; flush stdout
	if { $info(bmfsid) != 0 } {
		puts "the if worked, setting bm to $info(bookmark)"
		set_bm $info(bmfsid) $info(bookmark)
		event send $TmkEvent::EVT_REMOTEEVENT [binary format II 26 0]
		set info(bmfsid) 0
	}
   }
 }
 puts stdout "\n\ninserted [expr $bytes / 1048576] meg at $dr"
 catch { close $outf }
}


proc data_out { c outf } {
global info
 set chunksize 131072 ; set chunknum 0 ; set m 0
 for {set i 0} {$i < $c} {incr i $m} {
  set m [min $chunksize [expr $c - $i]]
  fcopy $info(fifo) $outf -size $m
  puts -nonewline "." ; flush stdout
  incr chunknum
  flush stdout
 }
puts ""
}


proc xml_from_tmf {} {
global info inf pbytes tarh xmldata nlen filename
 outd 2 "xml_from_tmf:"
 set inf $info(dc)
 set tarh [read $inf 512]
 set nlen [expr [string first \x00 $tarh] -1]
 set filename [string range $tarh 0 $nlen]
 outd 2 "tarpart is \"$filename\""
 set bytes [expr [string range $tarh 124 134]]
 set blocks [expr int($bytes / 512)]
 if { [expr $blocks * 512] < $bytes } { incr blocks }
 set pbytes [expr $blocks * 512 - $bytes]
 set xmldata [read $inf $bytes]
 set padding [read $inf $pbytes]
 return $xmldata
}

proc parse_xml { xmldata } {
global info ; set p 3
outd 2 "parse_xml:"
 set info(attributes) "Title Description EpisodeTitle StartDate StopDate StartTime StopTime Duration Date OriginalAirDate CallSign Name Time"
 foreach item $info(attributes) { set info($item) "" }
 set cso_tags "Begin CommercialSkipOffset End" ; set info(parts_csos) ""
 set xml_lines [split $xmldata "\n"]
 foreach line $xml_lines {
  foreach item $info(attributes) {if {[regexp "<$item>" $line]} {set info($item) [item_from_xml_line $line $item]}}
  foreach item $cso_tags {
   if {[regexp "<$item>" $line]} {
	set data [item_from_xml_line $line $item]
	switch $item {
	 Begin	{ append info(parts_csos) "\{$data " }
	 End	{ append info(parts_csos) "$data\} " }
	 CommercialSkipOffset { append info(parts_csos) "$data " }
	}
   }
  }
 }
 foreach item $info(attributes) { outd $p "$item is \"$info($item)\"" }
 foreach part $info(parts_csos) { outd $p "\"$part\"" }
}

proc item_from_xml_line { line item } {
 set il [expr [string length $item] + 2]
 set sindex  [expr [string first "<$item>" $line] + $il]
 set sindex2 [expr [string first "</$item>" $line] - 1]
 set data [string range $line $sindex $sindex2]
 return $data
}

proc set_rec_csos { recfsid } {
global info db ; set p 2
outd $p "set_rec_csos: recobj\{$recfsid\}"
 set xml_pts [llength $info(parts_csos)]
 RetryTransaction { set rec [db $db openid $recfsid] ; set Parts [dbobj $rec get Part] }
 set db_pts [llength $Parts]
 outd $p "\"$xml_pts\" xml parts and \"$db_pts\" db parts"
 if { $xml_pts != $db_pts } { outd 0 "mismatch, not setting csos" ; return }
 RetryTransaction {
  set rec [db $db openid $recfsid] ; set Parts [dbobj $rec get Part]
  set index 0
  foreach Part $Parts {
	set csos_data [lindex $info(parts_csos) $index]
	dbobj $Part set Begin [lindex $csos_data 0]
	dbobj $Part set End [lindex $csos_data end]
	set ntl [expr [llength $csos_data] - 2]
	set csos [lrange $csos_data 1 $ntl]
	foreach cso $csos { dbobj $Part add CommercialSkipOffset $cso }
	incr index
  }
 }
 unset info(parts_csos)
}

proc setrecinfo { recfsid } {
global info db ; set p 1
 outd $p "setrecinfo: recobj\{$recfsid\}"
 set progitems "Title Description EpisodeTitle OriginalAirDate"
 set showingitems "Date Duration Time"
 set recitems "StartDate StartTime StopDate StopTime"
 set stationitems "CallSign Name"
 RetryTransaction {
set rec [db $db openid $recfsid] ; set showing [dbobj $rec get Showing]
set program [dbobj $showing get Program] ; set station [dbobj $showing get Station]
foreach item $progitems { if { $info($item) != "" } { dbobj $program set $item $info($item) } }
foreach item $showingitems { if { $info($item) != "" } { dbobj $showing set $item $info($item) } }
foreach item $recitems { if { $info($item) != "" } { dbobj $rec set $item $info($item) } }
foreach item $stationitems { if { $info($item) != "" } { dbobj $station set $item $info($item) } }
 }
outd $p "\{$info(Title)\}\{$info(EpisodeTitle)\}\n$info(Description)"
}

proc make_blank_rec { ProgramTitle } {
global info version db ; set p 1
outd $p "make_blank_rec: \"$ProgramTitle\""
 if { $ProgramTitle == "" } { set ProgramTitle "unknown title - inserting" }
 set date [expr [clock seconds] / 86400]
 set time [expr [expr [clock seconds] % 86400] ]
 RetryTransaction {
  set recording [db $db create Recording]
  set recordingfsid [ dbobj $recording fsid ]
  dbobj $recording set BitRate 0
  dbobj $recording set ErrorString "mfs_ftp insert"
  dbobj $recording set ExpirationTime 0 ; 
  dbobj $recording set RecordQuality 100
  dbobj $recording set Score 100 ; dbobj $recording set State 3
  if { $info(saveuntil) == "delete" } {
   dbobj $recording set ExpirationDate 24855
   dbobj $recording set SelectionType 4
  } else {
   dbobj $recording set ExpirationDate [expr $date + 7*86400]
   dbobj $recording set SelectionType 6
  }
  dbobj $recording set StartDate $date ; dbobj $recording set StopDate $date
  dbobj $recording set StartTime $time
  dbobj $recording set StopTime [expr $time + 60]
  set station [db $db create Station]
  dbobj $station set CallSign	"mfs_ftp"
  dbobj $station set Name	"mfs_ftp"
  if { $version >= 3 } {
	dbobj $recording set UsedBy 1
	set recordingbehavior [db $db createsub RecordingBehavior $recording]
	foreach Behavior {DiskBehavior PresentationBehavior ProgramGuideBehavior} { dbobj $recordingbehavior set $Behavior 1 }
	dbobj $recordingbehavior set TunerBehavior 3
	dbobj $recording set RecordingBehavior $recordingbehavior
  }
  set showing [db $db createsub Showing $recording]
  dbobj $showing set Date $date ; dbobj $showing set Duration 60
  dbobj $showing set Station $station ; dbobj $showing set Time $time
  dbobj $recording set Showing $showing ; dbobj $recording set StreamFileSize 0
  set program [db $db create Program]
  dbobj $program set Title "$ProgramTitle" ; dbobj $program set OriginalAirDate "$date"
  dbobj $showing set Program $program
 }
 outd $p "created blank recording \{$recordingfsid\}" ; return $recordingfsid
}

proc finalize_rec { recfsid } {
global info db ; set p 1
 outd $p "finalize_rec: \"$recfsid"
 RetryTransaction { dbobj [db $db openid $recfsid] set State 4 }
 set info($recfsid,State) 4
}

proc AddPart { rec_fsid streamsize } {
global info db ; set p 3
 outd $p "AddPart: \"$rec_fsid\" - \"$streamsize\" bytes"
 set ev "FsStream::Create failed" ; set i 0
 while { [string range $ev 0 22] == "FsStream::Create failed" } {
  catch { RetryTransaction {
   catch { set new_part [mfs streamcreate 131072 [expr $streamsize / 131072]] } ev
   outd $p "AddPart stream allocate errval \n\"$ev\""
   if { [string range $ev 0 22] != "FsStream::Create failed" } {
	set rec [db $db openid $rec_fsid]
	set part [db $db createsub RecordingPart $rec]
	dbobj $rec add Part $part
	dbobj $part set File $new_part
	dbobj $rec set StreamFileSize $info(totalsize)
   }
  }
 } retryev
 outd $p "AddPart: retryev\n\"$retryev\""
  if { [string range $ev 0 22] == "FsStream::Create failed" } {
   incr i
   set wasted [shear_active $streamsize 1]
   if { $wasted != 0 } { set i 0 }
   if { $i >= 2 } { shear_suggestions $streamsize $rec_fsid 1] }
   if { $i >= 6 } {
	update_rec_fsids
	DELE stdout "DELE $rec_fsid"
	phoenix_mfs_ftp stdout "unable to allocate space for recording, you MUST delete something from Now Playing"
   }
   outd -1 "AddPart: streamcreate failed, i == $i, retrying in 3 seconds"
   after 2500
  }
 };#while
 event send $TmkEvent::EVT_DATA_CHANGED $TmkDataChanged::RECORDINGS_ON_DISK 0
 outd 1 "added part \"$new_part\" of \"[expr $streamsize / 1048576]\" meg"
 return $new_part
}

proc shear_suggestions { size recfsid {print 0} } {
global info db
puts "shear suggestions"
 set NS "" ; set dfsid -1
 ForeachMfsFile fsid name type $info(mfspath) "" {
   RetryTransaction {  
	set obj [db $db openid $fsid]
	set State [dbobj $obj get State]
	set ST [dbobj $obj get SelectionType]
	if { $State == 4 && $ST == 6 && $fsid != $recfsid } {
	 if { $print == 1 } { puts "$fsid is a winner" }
	 set dfsid $fsid
	}
   }
 }
 DELE stdout "DELE $dfsid"
 return
}

proc shear_active { size {print 0} } {
global info db ; set p 1
 set Active [get_active 1]
 # for every visible rec, remove it from the possible shear list
 ForeachMfsFile fsid name type $info(mfspath) "" {
  set index [lsearch -exact $Active $fsid]
  set State 4
  # if we're running set info(active) 1 check recfsid State
  if { $info(active) == 1 } { RetryTransaction { set rec [db $db openid $fsid] ; set State [dbobj $rec get State] } }
  # exclude anything visible from the don't nuke list
  if { $State != 5 } { set Active [lreplace $Active $index $index ] }
 }
 set wasted [llength $Active]
 if { $print == 1 } { outd $p "wasted is $wasted fsids \n$Active" }
 set trash [lindex $Active [expr [llength $Active] -1] ]
 foreach item $trash { close_shave $item 1 }
 return $wasted
}

proc get_active { {print 0} } {
global db ; set p 1
 set Active ""
 ForeachMfsFile fsid name type "/Recording/Active" "" { 
  if { [get_size $fsid ] > 0 } { lappend Active $fsid } 
 }
 if { $print == 1 } { 
  outd $p "/Recording/Active is [llength $Active] fsids \n$Active"
 }
 return $Active
}

proc get_size { recobj {print 0} } {
global db ; set p 3
 set tsize 0
 RetryTransaction {
  set obj [db $db openid $recobj]
  set Parts [dbobj $obj get Part]
  foreach part $Parts {
   set File [dbobj $part get File]
   if { [catch { mfs streamsize $File } p_s ] } {
	set psize 0
   } else {
	set psize [expr [lindex $p_s 1] * [lindex $p_s 0] / 1024 / 1024] 
   }
   set tsize [expr $tsize + $psize]
  }
 }
 if { $tsize > 0 && $print == 1 } { outd $p "recobj $recobj total size $tsize" }
 return $tsize
}

proc SYST { args fsock } {
 tee $fsock "215 UNIX"
}

proc TYPE { args fsock } {
 tee $fsock "200 Type set to I"
}

proc USER { fsock line } {
 outd 1 "USER: \"[string range $line 5 end]\""
 tee $fsock "331 User name okay, need password."
}

proc PASV { args fsock } {
global pdcs info ; set p 1
 outd $p "PASV: closing info(dc) just in case"
 catch { close $info(dc) } errval
 outd 1 "catch close info(dc) \"$errval\""
 outd $p "closing pdcs just in case"
 catch { close $pdcs } errval
 outd $p "errval \"$errval\""
 set info(mode) "PASV_waiting"
 set option1 [lindex $args 1] ; set ipaddr $info(localip)
 set lport [expr $info(port) - 1] ; set lp1 [expr $lport / 256]
 set lp2 [expr $lport - ($lp1 * 256)] ; set lportftp "$lp1,$lp2"
 outd $p "attempting to setup callback"
 set pdcs [socket -server newpdc $lport]
 outd $p "passive data channel \"$info(localip):$lport\""
 tee $fsock "227 Entering Passive Mode ($ipaddr,$lportftp)."
}

proc newpdc {sock addr port} {
global pdcs info ; set p 1
 outd $p "newpdc: open data channel $sock - connect from \"$addr:$port\""
 set info(mode) PASV_connect
 outd $p "closing server data socket \"$pdcs\" to new connections"
 catch { close $pdcs } errval ; outd $p "errval \"$errval\""
 outd $p "passive data channel info(dc) set to $sock"
 set info(dc) $sock
 fconfigure $sock -buffersize 4096 -translation binary
}

proc PORT { line fsock } {
global info pdcs ; set p 1
 outd 1 "$line"
 catch { close $pdcs }
 set info(mode) PORT
 set args [split $line \ ,]
 set ip1 [lindex $args 1] ; set ip2 [lindex $args 2]
 set ip3 [lindex $args 3] ; set ip4 [lindex $args 4]
 set ip5 [lindex $args 5] ; set info(portip) $ip1.$ip2.$ip3.$ip4
 set portoffset [lindex $args 6]
 set info(cport) [expr $ip5 * 256 + $portoffset]
 set info(dc) [socket $info(portip) $info(cport)]
 outd $p "data channel \"$info(dc)\" to $info(portip):$info(cport)"
 fconfigure $info(dc) -buffersize 4096 -translation binary
 tee $fsock "200 PORT command successful."
}

proc setup_control_socket {port} {
global control_socket info ; set p 1
 outd $p "setup_control_socket:"
 set control_socket(main) [socket -server newcsocket $port]
 outd $p "\"$info(localip):$info(port)\" ready for connections"
}

proc newcsocket {sock addr port} {
global control_socket info ; set p 1
 outd $p "newcsocket: \{$sock\} \"$addr:$port\""
 abortcheck "newcsocket"
 set control_socket(addr,$sock) [list $addr $port]
 fconfigure $sock -buffering line
 tee $sock "220 Mfs_Ftp ver $info(version) - \{$sock\} from \"$addr:$port\""
 fileevent $sock readable [list readlinefromsocket $sock]
 set info(dir) "/" ; set sinfo [fconfigure $sock -sockname]
 set sinfo [split $sinfo \ ] ; set sinfo [lindex $sinfo 0]
 regsub -all \\. $sinfo , info(localip)
 outd $p "serverip \"$sinfo\""
}

proc readlinefromsocket { sock } {
global control_socket info ; set p 4
 outd $p "readlinefromsocket: \"$sock\""
 if { [eof $sock] || [catch {gets $sock line}] } {
  outd $p "control connection lost - closing socket"
  catch { close $sock }
  outd $p "unset control_socket(addr,$sock)"
  catch { unset control_socket(addr,$sock) }
 } else { 
  outd 4 "echo to verify: \"$line\"" ; parseline $line $sock 
 }
}

proc parseline { line fsock } {
global info control_socket ; set p 4
 outd $p "parseline:\n\"$line\""
 set args [split $line] ;set cmd [lindex $args 0]
 set info(lastsock) $fsock
 switch $cmd {
  USER	{ USER	$fsock	$line }
  PASS	{ PASS	$fsock  $line }
  CWD	{ CWD	$args	$fsock }
  CDUP	{ CDUP	$fsock }
  DELE	{ DELE  $fsock $line }
  PORT	{ PORT	$line	$fsock }
  PASV	{ PASV	$args	$fsock }
  QUIT	{ QUIT	$fsock }
  TYPE	{ TYPE	$args	$fsock }
  MODE	{ MODE	$args	$fsock }
  REST    { REST  $fsock $line }
  RETR	{ RETR	$fsock $line }
  STOR	{ STOR	$fsock $line }
  XPWD	{ PWD	$args	$fsock }
  PWD	{ PWD 	$args	$fsock }
  LIST	{ NLST	$line	$fsock }
  NLST	{ NLST	$line	$fsock }
  SYST	{ SYST	$args	$fsock }
  NOOP	{ NOOP	$args	$fsock }
  exit	{ exitproc $fsock raw_ftp_command_exit }
  EXIT	{ exitproc $fsock raw_ftp_command_EXIT }
  PHOENIX	{ phoenix_mfs_ftp $fsock raw_ftp_command_PHOENIX }
  default { tee $fsock "502 Command not implemented \"$line\"" }
 }
}

proc get_tzoffset { } {
global info ; set p 2
 outd 1 "get_tzoffset:"
 if { [file exist $info(path)/tzoffset.txt] } {
  outd $p "sourcing tzoffset.txt"
  source $info(path)/tzoffset.txt
 } else {
  if { [file exist $info(path)/tzoffset.tcl] } {
	outd $p "tzoffset.txt not found, executing tzoffset.tcl"
	exec $info(path)/tzoffset.tcl 2>/dev/null
	after 500
	get_tzoffset
  } else {
	outd $p "unable to locate tzoffset.txt or tzoffset.tcl"
  }
 }
}

proc reset_control_socket { } {
global info control_socket ; set p 1
 outd $p "reset_control_socket:"
 catch { close $info(lastsock) } errval
 puts stdout "catch close lastsock val \"$errval\""
 catch { close $control_socket(main) }
 set info(dir) "/"
 set info(mode) normal
 setup_control_socket $info(port)
}

proc background { } {
global info ; set p 2
 outd $p "info(background) is \"$info(background)\" so..."
 if { $info(background) != "foreground" && $info(background) != "backgrounded"} {
  outd $p "entering background"
  exec $info(path)/mfs_ftp.tcl $info(port) backgrounded >$info(path)/port.$info(port).log &
  exit
 }
 outd $p "NOT entering background, echoing status msgs to console"
}

proc dump_xml { obj } {
global db info ; set p 4
 outd $p "dump_xml: recobj\{$obj\}"
 set version [dbobj [db $db open "/SwSystem/ACTIVE"] get Name]
 set output "<?xml version=\"1.1\" tivoversion=\"$version\"?>\n"
 append output [dump_object $obj "_top"]
 unset ::seen
 return $output
}

proc dump_object { obj {id ""} {depth 10} {prefix ""}} {
global info ; set p 4
 outd $p "dump_object: \"$obj\" \"$id\" \"$depth\" \"$prefix\" "
 if { $depth == 0 } {return "** max depth **\n"}
 set output "" ; set fsid [dbobj $obj fsid] ; set subid [dbobj $obj subobjid]
 if { [info exists ::seen($fsid/$subid)] } { return {} }
 set ::seen($fsid/$subid) "$id"
 set otype [dbobj $obj type]
 if {[dbobj $obj primary]} {
   append output "$prefix<Object type=\"$otype\" id=\"$id\">\n"
   set endtag "</Object>"
 } else {
   append output "$prefix<SubObject type=\"$otype\" id=\"$id\">\n"
   set endtag "</SubObject>"
 }
 foreach attr [lsort [dbobj $obj attrs]] {
   if { [catch { dbobj $obj get $attr } attrs] } {
	outd 1 "dump_obj: whoops, wacky db attr \"$attr\""
   } else {
     set atype [dbobj $obj attrtype $attr]
     switch -glob $attr {
	AuxInfos -
	ActualShowing -
	CancelReason -
	Deletion* -
	Expiration* -
	ErrorString -
	Index* -
	NSecondsWatched -
	NVisit -
	ProgramSource -
	RecordingBehavior -
	Score -
	State -
	Version {continue}
     }
     foreach a $attrs {
	switch $atype {
	object { append output [dump_object $a $attr [expr $depth-1] "$prefix "]; set a "" }
     }
     if { $a != "" } { append output "$prefix  <$attr>$a</$attr>\n" }
   }
 }
 }
 append output "$prefix$endtag\n"
 return "$output"
}

proc set_bm { fsid sec } {
global db info ; set p 2
 outd $p "set_bm: recobj\{$fsid\} $sec"
 RetryTransaction {
  set rec [db $db openid $fsid]
  set Bookmark [dbobj $rec get Bookmark]
  if { $Bookmark == "" } { set Bookmark [db $db createsub Bookmark $rec] ; dbobj $rec set Bookmark $Bookmark }
  dbobj $Bookmark set TimeMs [expr $sec*1000+1]
  if { $sec < 2 } { dbobj $rec remove Bookmark }
 }
}

proc bookmark_juggle { recfsid } {
global info mwStateG ; set p 1
 outd $p "bookmark_juggle"
 set info(bookmark) 0 ; set info(bmfsid) 0
 if { [get_context] == 6 } {
  set title [GetVal "context.pBannerWidgetM.title"]
  outd $p "inserting \"$info(Title)\" watching \"$title\""
  if { $info(Title) == $title } {
    event send $TmkEvent::EVT_REMOTEEVENT [binary format II 26 0]
    get_mwstate
    set currentPos [GetVal "context.pReplayWidgetM.currentPos"]
    outd $p "currentpos \"$currentPos\""
    set loops 0
    while {[get_context] != 7  } {
	event send $TmkEvent::EVT_REMOTEEVENT [binary format II 32 0]
	after 1000 ; incr loops
	outd $p "aquire recording info, attempt $loops"
	if { $loops > 9 } { break }
    }
    if { $loops < 10 } {
	set fsid [GetVal "context.pCurrentRecordingM"] ;#context 7
	set sindex  [expr [string first "/" $fsid] -1]
	set fsid [string range $fsid 0 $sindex ]
	outd $p "current fsid \"$fsid\""
	if { $fsid == $recfsid } {
		outd $p "paydirt! the fsids match!!! - setting bookmark to \"$currentPos\""
		set info(bookmark) $currentPos
		set info(bmfsid) $recfsid
	} else {
		outd $p "the fsid's don't match, nevermind"
		event send $TmkEvent::EVT_REMOTEEVENT [binary format II 26 0]
	}
    } else {
	outd $p "couldn't get fsid"
	#event send $TmkEvent::EVT_REMOTEEVENT [binary format II 26 0]
    }
  } else {
   outd $p "nevermind, not watching the insert :p"
  }
 } else {
  outd $p "nevermind, not on a video screen"
 }
 #4 select, 6 dumpstate, 27 pause, 32 nowshowing, 26 play, 3 right
};#end of proc

proc get_context { } {
global mwStateG
 get_mwstate
 set lines [split $mwStateG]
 outd 2 "mwstate first line is \"[lindex $lines 0]\""
 if { [lindex $lines 0] != "context" } { return 2 }
 return [GetVal "context.id"]
}

proc get_mwstate { } {
global mwStateG
 catch { file delete /tmp/mwstate }
 after 100
 while { [file exist /tmp/mwstate] < 1 } {
  event send $TmkEvent::EVT_MWUSEREVENT 0 [binary format II 6 0]
  after 1000
 }
 after 1000
 set mwStateG [catvar /tmp/mwstate]
}

proc GetVal { fullpath } {
global mwStateG
 set path [split $fullpath "."]
 set tree $mwStateG
 while { [llength $tree] > 0 && [llength $path] > 0 } {
  for { set i 0 } { $i < [llength $tree] && [lindex $tree $i] != [lindex $path 0]} { incr i 2 } {}
  if { [lindex $tree $i] != [lindex $path 0] } {
   error "/tmp/mwstate: $fullpath: [lindex $path 0] not found"
   return
  }
  set tree [lindex $tree [expr $i + 1]]
  set path [lrange $path 1 end]
 }
 return $tree
}

proc setpri { prog_pri channel chan_pri } {
global info ; set p 1
 if { [file exist $info(path)/setpri] } {
  outd $p "set priorities: mfs_ftp $prog_pri % I/O chan $chan_pri %"
  set prog_pid [pid $info(dc)] ; set chan_pid [pid $channel]
  catch { exec $info(path)/setpri fifo $prog_pri $prog_pid }
  catch { exec $info(path)/setpri fifo $chan_pri $chan_pid }
 } else { 
  outd 0 "$info(path)/setpri not found, unable to adjust priority" 
 }
}

proc get_DC_key { } {
 set xml ""
 set db [dbopen]
 RetryTransaction {
  set obj [db $db open "/State/Media"]
  set ObjAttrs [dbobj $obj attrs]
  foreach attribute $ObjAttrs {
	set info [dbobj $obj get $attribute]
	append xml "<$attribute>$info</$attribute>\n"
  }
 }
 return $xml
}

proc dump_DC_key { } {
global info set p 2
 outd $p "backing up tivo & drive specific scramblekeys to $info(path)/DC_key.xml"
 set dc_key [get_DC_key]
 catch_var $dc_key $info(path)/DC_key.xml
}

proc outd { debuglevel string } {
global info
 set elapsed [clock format [expr [clock seconds] + $info(tzoffset)] -format "%I:%M:%S:%p"]
 if { $info(dbl) >= $debuglevel } { puts stdout "$elapsed - $string" }
}

proc tee { fsock string } {
 outd -1 $string
 if { $fsock != "stdout" } { catch { puts $fsock $string } }
}

proc min { a b } {
	if { $a < $b } { return $a } else { return $b }
}

proc strim { str } {
 set not_me "/ : ;"
 foreach item $not_me { regsub -all $item $str {} str }
 return [string trim $str "\{\}"]
}

proc ntrim { str } {
 set not_me "/ : ;"
 foreach item $not_me { regsub -all $item $str {} str }
 return [string trim $str "\{\}"]
}

proc versioncheck { } {
global version info db ; set p 2
 outd $p "versioncheck:"
 RetryTransaction { set version [dbobj [db $db open "/SwSystem/ACTIVE"] get Name] }
 set info(tswv) $version
 set version [string range $version 0 0]
 set info(mfspath) "/Recording/NowShowingByClassic"
 if { $version == "2" } { set info(mfspath) "/Recording/NowShowing" }
 if { $info(active) == 1 } { set info(mfspath) "/Recording/Active" }
 outd 1 "init: $info(version) - TiVo_OS $info(tswv)"
 outd $p "tivo version \"$version.x\" mfspath set to $info(mfspath)"
}

proc isInt { val } {
global info ; set p 4
outd $p "isInt:"
    return [regexp {^-?[1-9][0-9]*$|^-?0[xX][0-9a-fA-F]+$|^-?0[0-7]*$} $val]
}

proc spawn { filetype } {
global info control_socket
 if { $info(multithreaded) == 1 } {
  switch  $filetype {
	txt { }
	xml { }
	sp  { }
	default {
	 set info(ac_interval) 14
	 catch { close $control_socket(main) }
	 exec $info(path)/mfs_ftp.tcl $info(port) backgrounded 2>& stdout &
	}
  }
 }
}

proc ping_pong { } {
global info
 abortcheck "ping_pong"
 after [expr $info(ac_interval) * 1000] ping_pong
}

proc abortcheck { {callingproc ""} } {
global info
 outd 1 "abortcheck: \"$callingproc\""
 if [file exist $info(path)/abort.txt] { outd -1 "found abort.txt, exiting" ; exit }
 if { [expr [clock seconds] - $info(update_last)] > 1800 } { after 5000 update_rec_fsids }
 if { $info(ac_interval) < 15  } { exitproc stdout ac_intv_bail }
}


proc exitproc { sock callingproc } {
global control_socket info
 tee  $sock "200 shutting down the server NOW from \"$callingproc\""
 catch { close $control_socket(main)}
 catch {close $sock} ; set forever end ; exit
}

proc phoenix_mfs_ftp { fsock callingproc } {
global info
 tee $fsock "$callingproc quiting mfs_ftp.tcl and forking a new one"
 after 200
 exec $info(path)/mfs_ftp.tcl $info(port) $info(background) 2>& stdout &
 exitproc stdout phoenix_mfs_ftp
}

proc nuke_rubbish { } {
 #RubbishObjectByFsId trashes recs - this empties the trash
 #/tvbin/fsfix -nokill -splash -uncollide -rehash -salvage -reboot
 ForeachMfsFile id name type /Rubbish "" {
  RetryTransaction { mfs unlink /Rubbish/$name }
 }
}

proc catch_var { data file } {
global info ; set p 3
 outd $p "open/create \"$file\" & writing\n$data\n"
 set outf [open $file w] ; fconfigure $outf -translation binary
 puts -nonewline $outf $data ; close $outf
}

proc bgerror { error } {
global info
 puts stdout "bgerror invoked with error \n \n \" $error \" \n"
 puts stdout "re-initializing mfs_ftp\n"
 puts stdout "close the current ftp connection and simply open another\n"
 set vars "version tswv dbl ithrottle insert_priority multithreaded saveuntil name_detail bjuggle active ac_interval gatewayip gatewayport"
 puts stdout "\"core dump\" :p\n"
 foreach var $vars { puts stdout "info($var): $info($var)" }
 puts stdout "\n"
 catch { close $info(dc) }
 abortcheck "bgerror"
 after 100 reset_control_socket
}

set db [dbopen]
EnableTransactionHoldoff true
init_vars
init_procs
set forever start
vwait forever