#-- Patch for mfs_ftp released by MrPenguin
#-- To install, copy p2.tcl to the mfs_ftp dir
#-- addresses DRM issues in 8.1 partly based from patch by by Brian Tuck (BTUx9 on DDB) 


proc make_blank_rec { ProgramTitle } {
global info version db ; set p 1
outd $p "make_blank_rec: \"$ProgramTitle\""
 if { $ProgramTitle == "" } { set ProgramTitle "unknown title - inserting" }
 set date [expr [clock seconds] / 86400]
 set time [expr [expr [clock seconds] % 86400] ]
 RetryTransaction {
  set recording [db $db create Recording]
  set recordingfsid [ dbobj $recording fsid ]
      
    #Add DRM stuff:
    	set drmobj [db $db createsub RecordingDrm $recording]
    	set dfsid [dbobj $drmobj fsid]
    	dbobj $drmobj set SignatureType 0
    	dbobj $recording set Drm $drmobj   	
    # end DRM stuff

  dbobj $recording set BitRate 0
  dbobj $recording set ErrorString "mfs_ftp insert"
  dbobj $recording set ExpirationTime 0 ;
  dbobj $recording set RecordQuality 100
  dbobj $recording set Score 100 ; dbobj $recording set State 3
  if { $info(saveuntil) == "delete" } {
   dbobj $recording set ExpirationDate 24855
   dbobj $recording set SelectionType 4
  } else {
#-- creates invalid exp. dates, may log continuously to tverr
#   dbobj $recording set ExpirationDate [expr $date + 7*86400]
   dbobj $recording set ExpirationDate [expr $date + 7]
   dbobj $recording set SelectionType 6
  }
  dbobj $recording set StartDate $date ; dbobj $recording set StopDate $date
  dbobj $recording set StartTime $time
  dbobj $recording set StopTime [expr $time + 60]
  set station [db $db create Station]
  dbobj $station set CallSign	"mfs_ftp"
  dbobj $station set Name	"mfs_ftp"
  if { $version >= 3 } {
	dbobj $recording set UsedBy 1
	set recordingbehavior [db $db createsub RecordingBehavior $recording]
	foreach Behavior {DiskBehavior PresentationBehavior ProgramGuideBehavior} { dbobj $recordingbehavior set $Behavior 1 }
	dbobj $recordingbehavior set TunerBehavior 3
	dbobj $recording set RecordingBehavior $recordingbehavior
  }
  set showing [db $db createsub Showing $recording]
  dbobj $showing set Date $date ; dbobj $showing set Duration 60
  dbobj $showing set Station $station ; dbobj $showing set Time $time
  dbobj $recording set Showing $showing ; dbobj $recording set StreamFileSize 0
  set program [db $db create Program]
  dbobj $program set Title "$ProgramTitle" ; dbobj $program set OriginalAirDate "$date"
  dbobj $showing set Program $program
 }
 outd $p "created blank recording \{$recordingfsid\}" ; return $recordingfsid
}



proc AddPart { rec_fsid streamsize } {
global info db ; set p 3
 outd $p "AddPart: \"$rec_fsid\" - \"$streamsize\" bytes"
 set ev "FsStream::Create failed" ; set i 0
 while { [string range $ev 0 22] == "FsStream::Create failed" } {
  catch { RetryTransaction {
   catch { set new_part [mfs streamcreate 131072 [expr $streamsize / 131072]] } ev
   outd $p "AddPart stream allocate errval \n\"$ev\""
   if { [string range $ev 0 22] != "FsStream::Create failed" } {
	set rec [db $db openid $rec_fsid]
	set part [db $db createsub RecordingPart $rec]
	dbobj $rec add Part $part
	dbobj $part set File $new_part
	dbobj $rec set StreamFileSize $info(totalsize)
	
	#add drm stuff
	
	set drmobj [db $db createsub RecordingPartDrm $part]
	  	set dfsid [dbobj $drmobj fsid]
	  	dbobj $drmobj set MediaEncryptionKeyOffset  0
	  	dbobj $drmobj set MediaEncryptionKeyType   0
	  	dbobj $drmobj set MediaSigningKeyType   0
	  	dbobj $drmobj set SignatureType     0
	  	dbobj $part set Drm $drmobj
	  	
	  # end DRM stuff
   }
  }
 } retryev
 outd $p "AddPart: retryev\n\"$retryev\""
  if { [string range $ev 0 22] == "FsStream::Create failed" } {
   incr i
   set wasted [shear_active $streamsize 1]
   if { $wasted != 0 } { set i 0 }
   if { $i >= 2 } { shear_suggestions $streamsize $rec_fsid 1] }
   if { $i >= 6 } {
	update_rec_fsids
	DELE stdout "DELE $rec_fsid"
	phoenix_mfs_ftp stdout "unable to allocate space for recording, you MUST delete something from Now Playing"
   }
   outd -1 "AddPart: streamcreate failed, i == $i, retrying in 3 seconds"
   after 2500
  }
 };#while
# event send $TmkEvent::EVT_DATA_CHANGED $TmkDataChanged::RECORDINGS_ON_DISK 0
 outd 1 "added part \"$new_part\" of \"[expr $streamsize / 1048576]\" meg"
 return $new_part
}
