#!/tvbin/tivosh
# (C)Copyright 2005 by Steve Brown
# Based on code by Turbo (Mike Byrne)
# All rights reserved

global Resources
global NumResources
global ResourceGroups
global ResourceGroupsNum
global ResourceGroupsNdx
global swsystemfsid
global db

proc TVUpdateResources { } {

   set db [dbopen]
   RetryTransaction {
      set swsystemfsid [lindex [mfs find /SwSystem/ACTIVE] 0]
   }
   RetryTransaction {
      set objSwSystem [db $db openid $swsystemfsid]
      set objResourceGroup [dbobj $objSwSystem get ResourceGroup]
      set objMpaaRating [lindex $objResourceGroup 0]
      catch { dbobj $objMpaaRating remove CompressedFile }
   }
   dbclose $db 
}


proc ResSetStringResourceValue { rGrp rItm rVal } {

   set db [dbopen]
   RetryTransaction {
      set swsystemfsid [lindex [mfs find /SwSystem/ACTIVE] 0]
   }
   
   RetryTransaction {
      set objSwSystem [db $db openid $swsystemfsid]
      set objResGroup [dbobj $objSwSystem get ResourceGroup $rGrp]
      set result [dbobj [dbobj $objResGroup get Item $rItm] set String $rVal]
   }
   dbclose $db 
   return $result
}

proc action_steve {} {
	
   # RecordQualityHigh
   set result [ResSetStringResourceValue 17 5 75] 
   # RecordQualityMedium
   set result [ResSetStringResourceValue 17 6 55] 
   

   # DBSBestVBRBitrate
   set result [ResSetStringResourceValue 17 8 5960000] 
   # DBSBestMaxBitrate
   set result [ResSetStringResourceValue 17 9 5960000] 
   # DBSBestResolution
   set result [ResSetStringResourceValue 17 10 4] 
   # DBSHighVBRBitrate
   set result [ResSetStringResourceValue 17 16 3660000] 
   # DBSHighMaxBitrate
   set result [ResSetStringResourceValue 17 17 3660000] 
   # DBSHighResolution
   set result [ResSetStringResourceValue 17 18 2] 
   # DBSMediumVBRBitrate
   set result [ResSetStringResourceValue 17 24 2760000] 
   # DBSMediumMaxBitrate
   set result [ResSetStringResourceValue 17 25 2760000] 
   # DBSMediumResolution
   set result [ResSetStringResourceValue 17 26 1] 
   # DBSBasicVBRBitrate
   set result [ResSetStringResourceValue 17 32 1700000] 
   # DBSBasicMaxBitrate
   set result [ResSetStringResourceValue 17 33 1700000] 
   # DBSBasicResolution
   set result [ResSetStringResourceValue 17 34 1] 

   # CATVBestVBRBitrate
   set result [ResSetStringResourceValue 17 40 5960000] 
   # CATVBestMaxBitrate
   set result [ResSetStringResourceValue 17 41 5960000] 
   # CATVBestResolution
   set result [ResSetStringResourceValue 17 42 2] 
   # CATVHighVBRBitrate
   set result [ResSetStringResourceValue 17 48 3660000] 
   # CATVHighMaxBitrate
   set result [ResSetStringResourceValue 17 49 3660000] 
   # CATVHighResolution
   set result [ResSetStringResourceValue 17 50 2] 
   # CATVMediumVBRBitrate
   set result [ResSetStringResourceValue 17 56 2760000] 
   # CATVMediumMaxBitrate
   set result [ResSetStringResourceValue 17 57 2760000] 
   # CATVMediumResolution
   set result [ResSetStringResourceValue 17 58 1] 
   # CATVBasicVBRBitrate
   set result [ResSetStringResourceValue 17 64 1700000] 
   # CATVBasicMaxBitrate
   set result [ResSetStringResourceValue 17 65 1700000] 
   # CATVBasicResolution
   set result [ResSetStringResourceValue 17 66 1] 

   # RooftopBestVBRBitrate
   set result [ResSetStringResourceValue 17 72 5960000] 
   # RooftopBestMaxBitrate
   set result [ResSetStringResourceValue 17 73 5960000] 
   # RooftopBestResolution
   set result [ResSetStringResourceValue 17 74 2] 
   # RooftopHighVBRBitrate
   set result [ResSetStringResourceValue 17 80 3660000] 
   # RooftopHighMaxBitrate
   set result [ResSetStringResourceValue 17 81 3660000] 
   # RooftopHighResolution
   set result [ResSetStringResourceValue 17 82 2] 
   # RooftopMediumVBRBitrate
   set result [ResSetStringResourceValue 17 88 2760000] 
   # RooftopMediumMaxBitrate
   set result [ResSetStringResourceValue 17 89 2760000] 
   # RooftopMediumResolution
   set result [ResSetStringResourceValue 17 90 1] 
   # RooftopBasicVBRBitrate
   set result [ResSetStringResourceValue 17 96 1700000] 
   # RooftopBasicMaxBitrate
   set result [ResSetStringResourceValue 17 97 1700000] 
   # RooftopBasicResolution
   set result [ResSetStringResourceValue 17 98 1] 

   TVUpdateResources
   puts "Resources reset to defaults" 
}



   
# do it
action_steve
