#!/tvbin/tivosh
# (C)Copyright 2005 by Steve Brown
# Setup Mode 0 (Option 2) values
# Based on code by Turbo (Mike Byrne)
# All rights reserved

global Resources
global NumResources
global ResourceGroups
global ResourceGroupsNum
global ResourceGroupsNdx
global swsystemfsid
global db

proc TVUpdateResources { } {

   set db [dbopen]
   RetryTransaction {
      set swsystemfsid [lindex [mfs find /SwSystem/ACTIVE] 0]
   }
   RetryTransaction {
      set objSwSystem [db $db openid $swsystemfsid]
      set objResourceGroup [dbobj $objSwSystem get ResourceGroup]
      set objMpaaRating [lindex $objResourceGroup 0]
      catch { dbobj $objMpaaRating remove CompressedFile }
   }
   dbclose $db 
}


proc ResSetStringResourceValue { rGrp rItm rVal } {

   set db [dbopen]
   RetryTransaction {
      set swsystemfsid [lindex [mfs find /SwSystem/ACTIVE] 0]
   }
   
   RetryTransaction {
      set objSwSystem [db $db openid $swsystemfsid]
      set objResGroup [dbobj $objSwSystem get ResourceGroup $rGrp]
      set result [dbobj [dbobj $objResGroup get Item $rItm] set String $rVal]
   }
   dbclose $db 
   return $result
}

proc action_steve {} {
	
   # RecordQualityHigh
   set result [ResSetStringResourceValue 17 5 75] 
   # RecordQualityMedium
   set result [ResSetStringResourceValue 17 6 55] 
   

   # DBSBestVBRBitrate
   set result [ResSetStringResourceValue 17 8 7500000] 
   # DBSBestMaxBitrate
   set result [ResSetStringResourceValue 17 9 9000000] 
   # DBSBestResolution
   set result [ResSetStringResourceValue 17 10 0] 
   # DBSHighVBRBitrate
   set result [ResSetStringResourceValue 17 16 5960000] 
   # DBSHighMaxBitrate
   set result [ResSetStringResourceValue 17 17 5960000] 
   # DBSHighResolution
   set result [ResSetStringResourceValue 17 18 4] 
   # DBSMediumVBRBitrate
   set result [ResSetStringResourceValue 17 24 3660000] 
   # DBSMediumMaxBitrate
   set result [ResSetStringResourceValue 17 25 6000000] 
   # DBSMediumResolution
   set result [ResSetStringResourceValue 17 26 0] 
   # DBSBasicVBRBitrate
   set result [ResSetStringResourceValue 17 32 1700000] 
   # DBSBasicMaxBitrate
   set result [ResSetStringResourceValue 17 33 2000000] 
   # DBSBasicResolution
   set result [ResSetStringResourceValue 17 34 1] 

   # CATVBestVBRBitrate
   set result [ResSetStringResourceValue 17 40 7500000] 
   # CATVBestMaxBitrate
   set result [ResSetStringResourceValue 17 41 9000000] 
   # CATVBestResolution
   set result [ResSetStringResourceValue 17 42 0] 
   # CATVHighVBRBitrate
   set result [ResSetStringResourceValue 17 48 5960000] 
   # CATVHighMaxBitrate
   set result [ResSetStringResourceValue 17 49 5960000] 
   # CATVHighResolution
   set result [ResSetStringResourceValue 17 50 4] 
   # CATVMediumVBRBitrate
   set result [ResSetStringResourceValue 17 56 3660000] 
   # CATVMediumMaxBitrate
   set result [ResSetStringResourceValue 17 57 6000000] 
   # CATVMediumResolution
   set result [ResSetStringResourceValue 17 58 0] 
   # CATVBasicVBRBitrate
   set result [ResSetStringResourceValue 17 64 1700000] 
   # CATVBasicMaxBitrate
   set result [ResSetStringResourceValue 17 65 2000000] 
   # CATVBasicResolution
   set result [ResSetStringResourceValue 17 66 1] 

   # RooftopBestVBRBitrate
   set result [ResSetStringResourceValue 17 72 7500000] 
   # RooftopBestMaxBitrate
   set result [ResSetStringResourceValue 17 73 9000000] 
   # RooftopBestResolution
   set result [ResSetStringResourceValue 17 74 0] 
   # RooftopHighVBRBitrate
   set result [ResSetStringResourceValue 17 80 5960000] 
   # RooftopHighMaxBitrate
   set result [ResSetStringResourceValue 17 81 5960000] 
   # RooftopHighResolution
   set result [ResSetStringResourceValue 17 82 4] 
   # RooftopMediumVBRBitrate
   set result [ResSetStringResourceValue 17 88 3660000] 
   # RooftopMediumMaxBitrate
   set result [ResSetStringResourceValue 17 89 6000000] 
   # RooftopMediumResolution
   set result [ResSetStringResourceValue 17 90 0] 
   # RooftopBasicVBRBitrate
   set result [ResSetStringResourceValue 17 96 1700000] 
   # RooftopBasicMaxBitrate
   set result [ResSetStringResourceValue 17 97 2000000] 
   # RooftopBasicResolution
   set result [ResSetStringResourceValue 17 98 1] 

   TVUpdateResources
   puts "Resources set to Mode 0 (Option 2) values" 
}



   
# do it
action_steve
